/*
 * MINIGUI - Harbour Win32 GUI library
 *
*/

#include "minigui.ch"
#include "metrocolor.ch"

//  !        
//     CP866     OEM-, 
// .. ZIP    OEM 
// 
//    - 2016/03/22: HMG Extended Edition version 16.03.
//  * Updated: Harbour Compiler 3.2.0dev (SVN 2016-03-18 17:42):
//         * Fixed: HbZipArc library source code to support the ASCII characters
//           above 128 in the name of files (see in folder \Source\HbZipArc).
//           Contributed by Grigory Filatov <gfilatov@inbox.ru>
//           (look at ReadMe.txt in folder \harbour)

/////////////////////////////////////////////////////////////////////////
//        1   2 
FUNCTION MyBackupZip(cPath,aFiles)
   LOCAL cIco  := "iZip48x2", cTitle 
   LOCAL cFont := 'Tahoma', nFontSize := ModeSizeFont()-4
   LOCAL aBackColor := NIL //COLOR_YELLOW_METRO  //    
   LOCAL aFButtColor1 := WHITE, aFButtColor2 := BLACK
   LOCAL cIco2x1, cIco2x2, cIco3x1, cIco3x2
   LOCAL hWnd, nMaxHeight, nMaxWidth, nCol
   LOCAL nWButt, nHButt, cButtCapt, nRowButt, nFButtSize := nFontSize-2
   LOCAL cFileZip, cStrSay, cResult, lRet

   cFileZip := cPath + "HbpZip" + DTOS(DATE()) + "-"+CharRepl( ":", Time(), "-" ) + ".zip"

   IF M->nPubLang == 1
      cStrSay := ' - ' + cFileNoPath(cFileZip)  
      cResult := '    !'
      cTitle  := ' '
   ELSE
      cStrSay := 'File - ' + cFileNoPath(cFileZip)  
      cResult := 'Archive file is successfully created !'
      cTitle  := 'Archive file'
   ENDIF

DEFINE WINDOW Form_Zip ;
	AT 0, 0 ;
	WIDTH 500 HEIGHT 330 ;
        TITLE cTitle         ;
        ICON cIco            ;
	MODAL NOSIZE         

      hWnd := GetFormHandle('Form_Zip') 
      nMaxWidth  := GetClientWidth(hWnd)   
      nMaxHeight := GetClientHeight(hWnd)

      @ 30,110 ANIMATEBOX Avi_1 ;
        WIDTH 40 HEIGHT 40  ;
        FILE 'ZIPAVI' AUTOPLAY TRANSPARENT NOBORDER

     @ 20,0 LABEL Label_S1 WIDTH nMaxWidth HEIGHT 30  ;
       VALUE cStrSay FONT cFont SIZE nFontSize-2 BOLD ;
       TRANSPARENT CENTERALIGN VCENTERALIGN  INVISIBLE 

     @ 50,0 LABEL Label_S2 WIDTH nMaxWidth HEIGHT 30  ;
       VALUE cPath FONT cFont SIZE nFontSize-2 BOLD ;
       TRANSPARENT CENTERALIGN  VCENTERALIGN  INVISIBLE 

     @ 90,20 LABEL Label_1 WIDTH nMaxWidth-20*2 HEIGHT 35  ;
        VALUE IIF( M->nPubLang == 1, ' :', 'Add file:' ) ;
	FONT cFont SIZE nFontSize+2 ;
        TRANSPARENT CENTERALIGN 

     @ 120,20 PROGRESSBAR ProgressBar_1 ;
        RANGE 0,100            ;
        VALUE 0                ;
        WIDTH nMaxWidth-20*2 HEIGHT 55  ;
        BACKCOLOR COLOR_BRIGHT_ORANGE
        FORECOLOR {0,130,0}

     @ 180,20 LABEL Label_2 WIDTH nMaxWidth-20*2 HEIGHT 35  ;
        VALUE cFileNoPath( cFileZip ) ;
	FONT cFont SIZE nFontSize-2 BOLD ;
        TRANSPARENT CENTERALIGN 


      /////////////////////// Button ////////////////////////////
      nWButt := 190  //    
      nHButt := 56   //   
      nRowButt := nMaxHeight - nHButt - 20 //    
        cButtCapt := IIF( M->nPubLang == 1, "" + CRLF + "", "Create" + CRLF + "archive" ) 
        nCol := ( nMaxWidth  - nWButt*2 )/2 - 10
        cIco2x1 := "iFloppy48x1"  ;  cIco2x2 := "iFloppy48x2"
        @ nRowButt, nCol BUTTONEX BUTTON_Save  WIDTH nWButt HEIGHT nHButt  ;
           CAPTION cButtCapt      ;
           ICON cIco2x1           ; 
           FONTCOLOR aFButtColor1 ;
           BACKCOLOR LGREEN       ;
           SIZE nFButtSize BOLD   ;
           NOXPSTYLE HANDCURSOR   ;
           ON MOUSEHOVER ( SetProperty(ThisWindow.Name, This.Name, "ICON", cIco2x2 ) ,;
                           SetProperty(ThisWindow.Name, This.Name, "fontcolor", aFButtColor2 ) ) ;
           ON MOUSELEAVE ( SetProperty(ThisWindow.Name, This.Name, "ICON", cIco2x1 ) ,;
                           SetProperty(ThisWindow.Name, This.Name, "fontcolor", aFButtColor1 ) ) ;
           ACTION {|| CreateZip(cFileZip,aFiles,cResult) } ;
           NOTABSTOP        

        cButtCapt := IIF( M->nPubLang == 1, "", "Cancel" ) 
        nCol := ( nMaxWidth  - nWButt*2 )/2 + nWButt + 10
        cIco3x1 := "iCancel48x1"  ;  cIco3x2 := "iCancel48x2"
        @ nRowButt, nCol BUTTONEX BUTTON_Exit  WIDTH nWButt HEIGHT nHButt  ;
           CAPTION cButtCapt      ;
           ICON cIco3x1           ; 
           FONTCOLOR aFButtColor1 ;
           BACKCOLOR RED          ;
           SIZE nFButtSize BOLD   ;
           NOXPSTYLE HANDCURSOR   ;
           ON MOUSEHOVER ( SetProperty(ThisWindow.Name, This.Name, "ICON", cIco3x2 ) ,;
                           SetProperty(ThisWindow.Name, This.Name, "fontcolor", aFButtColor2 ) ) ;
           ON MOUSELEAVE ( SetProperty(ThisWindow.Name, This.Name, "ICON", cIco3x1 ) ,;
                           SetProperty(ThisWindow.Name, This.Name, "fontcolor", aFButtColor1 ) ) ;
           ACTION { || lRet:=.F., ThisWindow.Release } ;
           NOTABSTOP        

	ON KEY ESCAPE ACTION Form_Zip.Release

END WINDOW

CENTER WINDOW Form_Zip
ACTIVATE WINDOW Form_Zip

Return Nil

/////////////////////////////////////////////////////////////////////////
Function CreateZip(cFileZip,aFiles,cResult)
Local nTotal, bBlock, lOverWrite, lStorePath, cPassword

nTotal := Len(aFiles)
IF nTotal > 0

   Form_Zip.BUTTON_Save.Visible := .F.

   Form_Zip.ProgressBar_1.RangeMin := 1
   Form_Zip.ProgressBar_1.RangeMax := nTotal
   MODIFY CONTROL Label_1 OF Form_Zip FONTCOLOR {0,0,0}


   bBlock := {|cFile, nPos| ProgressUpdate( nPos, cFile, nTotal, .T. ) }
   lOverWrite := .T.  //   
   lStorePath := .T.  //    
   cPassword := NIL

   COMPRESSFILES ( cFileZip , aFiles, bBlock, lOverWrite, lStorePath , cPassword )

   MODIFY CONTROL Label_1 OF Form_Zip FONTCOLOR RED 

   INKEYGUI(1000)

   Form_Zip.ProgressBar_1.Visible := .F.

   Form_Zip.Avi_1.Hide

   Form_Zip.BackColor := COLOR_YELLOW_METRO  //    

   Form_Zip.Label_1.Value := cResult 

   Form_Zip.Label_S1.Show 
   Form_Zip.Label_S2.Show 

   Form_Zip.ProgressBar_1.Visible := .T.

   Form_Zip.BUTTON_Exit.Caption := IIF( M->nPubLang == 1, "", "Exit")

ENDIF

Return Nil

/////////////////////////////////////////////////////////////////////////
Function ProgressUpdate( nPos, cFile, nTotal, lShowFileName )
   LOCAL nBegunok, cBegunok
   Default lShowFileName := .F.

   //MsgDebug(nPos, cFile, nTotal, lShowFileName)

   nBegunok := INT( ( nPos / nTotal ) * 100 )
   cBegunok := "   " + HB_NtoS(nBegunok)+"%"

   Form_Zip.ProgressBar_1.Value := nPos
   Form_Zip.Label_1.Value := cFileNoPath( cFile ) + cBegunok 

   if lShowFileName
      INKEYGUI(10)
   endif

Return Nil

*------------------------------------------------------------------------------*
//Function GETFILESCOUNTINZIP ( cFileName )
*------------------------------------------------------------------------------*
/*LOCAL i := 0 , hUnzip , nErr

	hUnzip := HB_UNZIPOPEN( cFileName )

	nErr := HB_UNZIPFILEFIRST( hUnzip )

	DO WHILE nErr == 0

		i++
		nErr := HB_UNZIPFILENEXT( hUnzip )

	ENDDO

	HB_UNZIPCLOSE( hUnzip )

Return i
*/
*------------------------------------------------------------------------------*
PROCEDURE COMPRESSFILES ( cFileName , aDir , bBlock , lOvr , lStorePath , cPassword )
*------------------------------------------------------------------------------*
LOCAL hZip , cZipFile , i

	if valtype (lOvr) == 'L'
		if lOvr == .t.
			if file (cFileName)
				delete file (cFileName)
			endif
		endif
	endif

	hZip := HB_ZIPOPEN( cFileName )
	IF ! EMPTY( hZip )
           FOR i := 1 To Len (aDir)
              if valtype (bBlock) == 'B'
             	 Eval ( bBlock , aDir [i] , i )     
              endif
              cZipFile := iif( lStorePath, aDir [i], cFileNoPath( aDir [i] ) )

              cZipFile := HB_ANSITOOEM( cZipFile ) 

              HB_ZipStoreFile( hZip, aDir [i], cZipFile, cPassword )
           NEXT
	ENDIF

	HB_ZIPCLOSE( hZip )

RETURN

