/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2016 Verchenko Andrey <verchenkoag@gmail.com>
*/

#include "minigui.ch"
#include "metrocolor.ch"
#include "Dbinfo.ch"

#define PATH_START   GetStartUpFolder()
#define PATH_BACKUP  GetCurrentFolder() + "\BACKUP\"  

MEMVAR oBrw1
/////////////////////////////////////////////////////////////////////////
FUNCTION MyButtonRun1()
    LOCAL cForm := ThisWindow.Name
    LOCAL nRetViewRecno := 0

    IF CheckPathProject()

       SetProperty(oBrw1:cParentWnd, oBrw1:cControlName, "Enabled", .F.)
       SetProperty(cForm, "oBut_1to2", "Visible", .T.) 
       SetProperty(cForm, "oBut_2to1", "Visible", .T.) 
       SetProperty(cForm, "oBut_Zip" , "Visible", .T.) 
       oBrw1:Reset()
       oBrw1:Refresh(.T.)  
       SetProperty(oBrw1:cParentWnd, oBrw1:cControlName, "Enabled", .T.)
       //    ChangeTable()  Form_Table.prg
       nRetViewRecno := 1  

       Foot5Size(5,oBrw1)  //    5- 
       Foot8Itog(8,oBrw1)  //    8-  

    ENDIF

RETURN nRetViewRecno

/////////////////////////////////////////////////////////////////////////
FUNCTION CheckPathProject()
   LOCAL cForm := ThisWindow.Name
   LOCAL cPath1, cPath2, cPathPrj 
   LOCAL lPrg, lCh, lC, lRc, lLib, lBak, lDbf
   LOCAL nTypeProcess, aFiles, aTypeExt := {} 
   LOCAL aTxt[10]

   //    HbpMerge.cnfg
   MyConfigLoad(@cPath1,@cPath2,@cPathPrj,@lPrg,@lCh,@lC,@lRc,@lLib,@lBak,@lDbf)

   IF LEN(cPath1) == 0 .OR. LEN(cPath2) == 0 .OR. LEN(cPathPrj) == 0 
      IF M->nPubLang == 1
         aTxt[1] := '  : '
         aTxt[2] := " 1 - "
         aTxt[3] := " 2 - "
         aTxt[4] := ""
         aTxt[5] := " - "
         aTxt[6] := '   !'
      ELSE
         aTxt[1] := 'No data to:'
         aTxt[2] := "Folder 1 -" 
         aTxt[3] := "Folder 2 -" 
         aTxt[4] := "or" 
         aTxt[5] := "The project - "
         aTxt[6] := 'Can not continue!'
      ENDIF 
      MsgStop( aTxt[1] + CRLF + CRLF + ;
               aTxt[2] + cPath1   + CRLF + CRLF + ;
               PADL(aTxt[4],20) + CRLF + CRLF + ;
               aTxt[3] + cPath2   + CRLF + CRLF + ;
               PADL(aTxt[4],20) + CRLF + CRLF + ;
               aTxt[5] + cPathPrj + CRLF + CRLF + ;
               aTxt[6] )
      RETURN .F.
   ENDIF

   IF !hb_FileExists(cPathPrj)
      IF M->nPubLang == 1
         aTxt[1] := '    !'
         aTxt[2] := '   !'
      ELSE
         aTxt[1] := 'Do not defined the project file!'
         aTxt[2] := 'Set the correct settings!' 
      ENDIF 
      MsgStop( aTxt[1] + CRLF + cPathPrj+ CRLF + CRLF +;
               aTxt[2] )
      RETURN .F.
   ENDIF

   IF !IsDirectory(cPath1)
      IF M->nPubLang == 1
         aTxt[1] := '  " 1" !'
         aTxt[2] := '   !'
      ELSE
         aTxt[1] := 'Is not defined "Folder 1" !'
         aTxt[2] := 'Set the correct settings!' 
      ENDIF 
      MsgStop( aTxt[1] + CRLF + cPath1 + CRLF + CRLF + aTxt[2] )
      RETURN .F.
   ENDIF

   IF !IsDirectory(cPath2)
      IF M->nPubLang == 1
         aTxt[1] := '  " 2" !'
         aTxt[2] := '   !'
      ELSE
         aTxt[1] := 'Is not defined "Folder 2" !'
         aTxt[2] := 'Set the correct settings!' 
      ENDIF 
      MsgStop( aTxt[1] + CRLF + cPath1 + CRLF + CRLF + aTxt[2] )
      RETURN .F.
   ENDIF

   IF !lPrg .AND. !lCh .AND. !lC .AND. !lRc .AND. !lLib .AND. !lBak .AND. !lDbf
      IF M->nPubLang == 1
         aTxt[1] := '    !'
         aTxt[2] := '  '
         aTxt[3] := ' "    " !'
         aTxt[4] := '   !'
      ELSE
         aTxt[1] := 'No data processing for!' 
         aTxt[2] := 'Adjust the settings in'
         aTxt[3] := ' "Processing file types within the project" !'
         aTxt[4] := 'I can not continue!'
      ENDIF 
      MsgStop( aTxt[1] + CRLF + CRLF + aTxt[2] + CRLF + ;
               aTxt[3] + CRLF + CRLF + aTxt[4] )
      RETURN .F.
   ENDIF

   IF lPrg ; AADD(aTypeExt,".prg" ) ; ENDIF
   IF lCh  ; AADD(aTypeExt,".ch"  ) ; ENDIF
   IF lC   ; AADD(aTypeExt,".c"   ) ; ENDIF
   IF lRc  ; AADD(aTypeExt,".rc"  ) ; ENDIF
   IF lLib ; AADD(aTypeExt,".lib" ) ; ENDIF
   IF lBak ; AADD(aTypeExt,".bak" ) ; ENDIF
   IF lDbf ; AADD(aTypeExt,".dbf" ) ; ENDIF

   cPathPrj := LOWER(cPathPrj)
   nTypeProcess := 0
   IF AT(".bc",cPathPrj) > 0
      IF M->nPubLang == 1
         aTxt[1] := '  " (.bc)"   !'
         aTxt[2] := '  !'
      ELSE
         aTxt[1] := 'Processing  "Projects(.bc)" is not implemented !'
         aTxt[2] := 'Make your own!' 
      ENDIF 
      MsgStop( aTxt[1] + CRLF + CRLF + aTxt[2] )
      RETURN .F.
   ELSEIF AT(".hbp",cPathPrj) > 0
      nTypeProcess := 1
   ELSEIF AT(".lst",cPathPrj) > 0
      nTypeProcess := 2
   ENDIF

   IF nTypeProcess == 0
      IF M->nPubLang == 1
         aTxt[1] := '    '
         aTxt[2] := '  !'
      ELSE
         aTxt[1] := 'I can not process the file '
         aTxt[2] := 'Make your own!' 
      ENDIF 
      MsgStop( aTxt[1] + cFileNoPath(cPathPrj)+' !' + CRLF + CRLF + aTxt[2] )
      RETURN .F.
   ENDIF
  
   SetProperty(cForm, "oBut_Comp", "Enabled", .F.) 
   SetProperty(cForm, "oBut_1to2", "Enabled", .F.) 
   SetProperty(cForm, "oBut_2to1", "Enabled", .F.) 
   SetProperty(cForm, "oBut_Zip" , "Enabled", .F.) 
   SetProperty(cForm, "oBut_Exit", "Enabled", .F.) 

   //     
   aFiles := LoadProject(nTypeProcess,cPathPrj,aTypeExt)
   aFiles := ASORT(aFiles)
   //    
   SaveDbf(aFiles, cPath1, cPath2)

   // MsgDebug("     !")
   //  -   
   // TestSaveDbf()

   SetProperty(cForm, "oBut_Comp", "Enabled", .T.) 
   SetProperty(cForm, "oBut_1to2", "Enabled", .T.) 
   SetProperty(cForm, "oBut_2to1", "Enabled", .T.) 
   SetProperty(cForm, "oBut_Zip" , "Enabled", .T.) 
   SetProperty(cForm, "oBut_Exit", "Enabled", .T.) 

RETURN .T.

/////////////////////////////////////////////////////////////////////////
//     
Function LoadProject(nTypeProcess, cPathPrj, aTypeExt)
   LOCAL nI, nJ, aFile, aDim, cStr, cFileExt, cFile, cFileIsx

   aFile := {}
   IF nTypeProcess == 1 .OR.  nTypeProcess == 2
      cStr := FILESTR(cPathPrj)
      aDim := HB_ATokens(cStr,CRLF,.F.,.F.)
      FOR nI := 1 TO LEN(aDim)
          cFileIsx := aDim[nI]
          cFile := LOWER(aDim[nI])
          FOR nJ := 1 TO LEN(aTypeExt)
             cFileExt := aTypeExt[nJ] 
             IF AT(cFileExt,cFile) > 0

                IF SUBSTR(cFile,1,1) == "#"      //  
                ELSEIF SUBSTR(cFile,1,1) == "/"  //  
                ELSEIF SUBSTR(cFile,1,2) == "-l" .AND. cFileExt == ".lib"
                  AADD( aFile, cFileIsx )
                ELSE
                  AADD( aFile, cFileIsx )
                ENDIF

             ENDIF
          NEXT
      NEXT

   ENDIF

RETURN aFile

/////////////////////////////////////////////////////////////////////////
//  -   
Function TestSaveDbf()
   LOCAL hIcon, hBmp, cFile, cAlias := ALIAS()

   SELECT(cAlias)
   GOTO TOP
   DO WHILE !EOF()

      cFile := ALLTRIM( (oBrw1:cAlias)->PATH1 ) + ALLTRIM( (oBrw1:cAlias)->FILE1 )

      //     
      hIcon := ICON_EXEREAD( cFile ) 
      hBmp  := BmpFromIcon( hIcon )  // a return handle bmp
      (cAlias)->FBMP  := hBmp        //  bmp    

      SKIP
   ENDDO

RETURN NIL

/////////////////////////////////////////////////////////////////////////
//    
Function SaveDbf(aFiles, cPath1, cPath2)
   LOCAL nI, cFileExt, cFile, cAlias := ALIAS()
   LOCAL lFile1, lFile2, hIcon, hBmp, cNew 

   cNew := IIF(M->nPubLang == 1, "", "new" )

   IF SUBSTR(cPath1, LEN(cPath1), 1) # "\" 
      cPath1 += "\"
   ENDIF
   IF SUBSTR(cPath2, LEN(cPath2), 1) # "\" 
      cPath2 += "\"
   ENDIF

   SELECT(cAlias)
   ZAP

   FOR nI := 1 TO LEN(aFiles)

      (cAlias)->( DbAppend() )
      (cAlias)->NN  := nI               // "C",  4, 0
      cFile := cPath1 + aFiles[nI]
      (cAlias)->DIR1    := " 1:"        // "C",  4, 0
      (cAlias)->DIR2    := " 2:"        // "C",  4, 0
      (cAlias)->PATH1   := cPath1       // "C", 90, 0
      (cAlias)->PATH2   := cPath2       // "C", 90, 0

      //     
      hIcon := ICON_EXEREAD( cFile ) 
      hBmp  := BmpFromIcon( hIcon )  // a return handle bmp
      (cAlias)->FBMP  := hBmp        //  bmp    

      IF FILE(cFile)
         (cAlias)->FILE1 := cFileNoPath(cFile) // "C", 50, 0
         (cAlias)->SIZE1 := FILESIZE(cFile)    // "N", 10, 0
         (cAlias)->DATE1 := FileDate(cFile)    // "D",  8, 0
         (cAlias)->TIME1 := FileTime(cFile)    // "C", 10, 0
         lFile1 := .T.
      ELSE
         lFile1 := .F.
      ENDIF 

      cFile := cPath2 + aFiles[nI]
      IF FILE(cFile)
         (cAlias)->FILE2 := cFileNoPath(cFile) // "C", 50, 0
         (cAlias)->SIZE2 := FILESIZE(cFile)    // "N", 10, 0
         (cAlias)->DATE2 := FileDate(cFile)    // "D",  8, 0
         (cAlias)->TIME2 := FileTime(cFile)    // "C", 10, 0
         lFile2 := .T.
      ELSE
         //(cAlias)->FILE2 := cFileNoPath(cFile)+" - " // "C", 50, 0
         lFile2 := .F.
      ENDIF 
      IF !lFile2 .AND. !lFile1
         (cAlias)->FILE1 := "  ??? - "+cFileNoPath(cFile) 
         (cAlias)->FILE2 := "  ??? - "+cFileNoPath(cFile) 
      ENDIF 

      IF lFile2 .AND. lFile1   //  
         IF (cAlias)->DATE2 == (cAlias)->DATE1  //  
            //  
            IF (cAlias)->TIME2 == (cAlias)->TIME1 //   
            ELSE
               IF (cAlias)->TIME2 > (cAlias)->TIME1  
                  (cAlias)->STATUS2 := cNew      // "C",  6, 0
                  (cAlias)->LCOPY := .T.         // "L",  1, 0
               ELSE
                  (cAlias)->STATUS1 := cNew      // "C",  6, 0
                  (cAlias)->LCOPY := .T.         // "L",  1, 0
               ENDIF
            ENDIF
         ELSE
            IF (cAlias)->DATE2 > (cAlias)->DATE1  //  
               (cAlias)->STATUS2 := cNew      
               (cAlias)->LCOPY := .T.         
            ELSE
               (cAlias)->STATUS1 := cNew      
               (cAlias)->LCOPY := .T.         
            ENDIF
         ENDIF
      ELSE
         IF lFile2 .AND. !lFile1   
            (cAlias)->STATUS2 := cNew       
            (cAlias)->LCOPY := .T.          
         ELSE
            (cAlias)->STATUS1 := cNew       
            (cAlias)->LCOPY := .T.          
         ENDIF
      ENDIF
      IF !lFile2 .AND. !lFile1
         (cAlias)->STATUS1 := "? .hbp" 
         (cAlias)->STATUS2 := "? .hbp" 
      ENDIF 

      cFile := cPath1 + aFiles[nI]   //   
      cFileExt := hb_FNameExt(cFile)
      (cAlias)->FILEEXT := cFileExt     
      IF LOWER(cFileExt) == ".dbf"
         (cAlias)->RUNFUNC := "DbfMerge"   
      ELSE
         (cAlias)->RUNFUNC := "WinMerge"   
      ENDIF
   NEXT

RETURN NIL

/////////////////////////////////////////////////////////////////////////
FUNCTION MyButtonRun2()   //  1  2
   LOCAL cForm := oBrw1:cParentWnd
   LOCAL cAlias := M->oBrw1:cAlias , cFileIndex, cFilterTo  
   LOCAL nMinRecno, nMaxRecno, nFWidth 

   SetProperty(oBrw1:cParentWnd, oBrw1:cControlName, "Enabled", .F.) 

   // -------     ----------
   SetProperty(cForm, "Sizable"   , .F. ) // NOSIZE
   SetProperty(cForm, "MaxButton" , .F. ) // NOMAXIMIZE
   //SetProperty(cForm, "MinButton" , .F. ) // NOMINIMIZE

   SetProperty(cForm, "oBut_Comp", "Visible", .F.) 
   SetProperty(cForm, "oBut_1to2", "Visible", .F.) 
   SetProperty(cForm, "oBut_2to1", "Visible", .F.) 
   SetProperty(cForm, "oBut_Zip" , "Visible", .F.) 
   SetProperty(cForm, "oBut_Exit", "Visible", .F.) 
   //    
   SetProperty(cForm, "oBut_Copy1to2", "Visible", .T.) 
   SetProperty(cForm, "oBut_Cancel"  , "Visible", .T.) 

   SELECT(cAlias)
   cFileIndex := DBINFO(DBI_FULLPATH) + ".cdx"
   IF FILE (cFileIndex)
      DELETE FILE (cFileIndex)
   ENDIF
   cFilterTo := "(''$STATUS1 .OR. 'new'$STATUS1) .AND. LCOPY"
   INDEX ON ("RECNO()") TAG("MENU_F1") TO (cFileIndex) FOR &cFilterTo ADDITIVE

   DbSetorder(1)
   nMaxRecno := OrdKeyCount()
   nMinRecno := 1

   oBrw1:Reset()
   oBrw1:Refresh(.T.) 
   //oBrw1:ResetVScroll()
   //    ( )
   If oBrw1:oVScroll != Nil 
      oBrw1:oVScroll:SetRange( nMinRecno, nMaxRecno ) 
      oBrw1:oVScroll:SetPos( oBrw1:RelPos( oBrw1:nLogicPos() ) ) 
   EndIf 
   
   nFWidth := GetClientWidth( GetFormHandle( cForm ) )
   //   , ..   
   _SetControlWidth ( oBrw1:cControlName, oBrw1:cParentWnd, nFWidth) 

   Foot5Size(5,oBrw1)  //    5- 
   Foot8Itog(8,oBrw1)  //    8-  

   SetProperty(oBrw1:cParentWnd, oBrw1:cControlName, "Enabled", .T.)

   IF nMaxRecno == 0
      //    
      SetProperty(cForm, "oBut_Copy1to2", "Visible", .F.) 
      SetProperty(cForm, "oBut_Copy2to1", "Visible", .F.) 
   ENDIF

RETURN NIL

/////////////////////////////////////////////////////////////////////////
FUNCTION MyButtonRun3()   //  2  1
   LOCAL cForm := oBrw1:cParentWnd
   LOCAL cAlias := M->oBrw1:cAlias , cFileIndex, cFilterTo  
   LOCAL nMinRecno, nMaxRecno, nFWidth 

   SetProperty(oBrw1:cParentWnd, oBrw1:cControlName, "Enabled", .F.) 

   // -------     ----------
   SetProperty(cForm, "Sizable"   , .F. ) // NOSIZE
   SetProperty(cForm, "MaxButton" , .F. ) // NOMAXIMIZE
   //SetProperty(cForm, "MinButton" , .F. ) // NOMINIMIZE

   SetProperty(cForm, "oBut_Comp", "Visible", .F.) 
   SetProperty(cForm, "oBut_1to2", "Visible", .F.) 
   SetProperty(cForm, "oBut_2to1", "Visible", .F.) 
   SetProperty(cForm, "oBut_Zip" , "Visible", .F.) 
   SetProperty(cForm, "oBut_Exit", "Visible", .F.) 
   //    
   SetProperty(cForm, "oBut_Copy2to1", "Visible", .T.) 
   SetProperty(cForm, "oBut_Cancel"  , "Visible", .T.) 

   SELECT(cAlias)
   cFileIndex := DBINFO(DBI_FULLPATH) + ".cdx"
   IF FILE (cFileIndex)
      DELETE FILE (cFileIndex)
   ENDIF
   cFilterTo := "(''$STATUS2 .OR. 'new'$STATUS2) .AND. LCOPY"
   INDEX ON ("RECNO()") TAG("MENU_F1") TO (cFileIndex) FOR &cFilterTo ADDITIVE

   DbSetorder(1)
   nMaxRecno := OrdKeyCount()
   nMinRecno := 1

   oBrw1:Reset()
   oBrw1:Refresh(.T.) 
   //oBrw1:ResetVScroll()
   //    ( )
   If oBrw1:oVScroll != Nil 
      oBrw1:oVScroll:SetRange( nMinRecno, nMaxRecno ) 
      oBrw1:oVScroll:SetPos( oBrw1:RelPos( oBrw1:nLogicPos() ) ) 
   EndIf 
   
   nFWidth := GetClientWidth( GetFormHandle( cForm ) )
   //   , ..   
   _SetControlWidth ( oBrw1:cControlName, oBrw1:cParentWnd, nFWidth) 

   Foot5Size(5,oBrw1)  //    5- 
   Foot8Itog(8,oBrw1)  //    8-  

   SetProperty(oBrw1:cParentWnd, oBrw1:cControlName, "Enabled", .T.)

   IF nMaxRecno == 0
      //    
      SetProperty(cForm, "oBut_Copy1to2", "Visible", .F.) 
      SetProperty(cForm, "oBut_Copy2to1", "Visible", .F.) 
   ENDIF

RETURN NIL

/////////////////////////////////////////////////////////////////////////
// oBrw1:aColumns[2]:bPostEdit := {|| MyCheckBox2() }  
FUNCTION MyCheckBox2(uVal,oBrw,lApp)       //    
   LOCAL cForm := oBrw:cParentWnd
   LOCAL nRecno, nOrder := INDEXORD()

   IF nOrder > 0
      oBrw:Reset()
      oBrw:Refresh(.T.) 
      nRecno := (oBrw:cAlias)->(OrdKeyCount())
      IF nRecno == 0
         //    
         SetProperty(cForm, "oBut_Copy1to2", "Visible", .F.) 
         SetProperty(cForm, "oBut_Copy2to1", "Visible", .F.) 
      ENDIF
   ENDIF

RETURN NIL

/////////////////////////////////////////////////////////////////////////
FUNCTION MyButtonRun4()   //  
   LOCAL cForm := oBrw1:cParentWnd
   LOCAL nI, nRecno, aFile :={}, cFile1, cFile2, cPath := PATH_BACKUP

   //    
   SetProperty(cForm, "oBut_Comp", "Visible", .F.) 
   SetProperty(cForm, "oBut_1to2", "Visible", .F.) 
   SetProperty(cForm, "oBut_2to1", "Visible", .F.) 
   SetProperty(cForm, "oBut_Zip" , "Visible", .F.) 
   SetProperty(cForm, "oBut_Exit", "Visible", .F.) 

   SELECT(oBrw1:cAlias)
   nRecno := (oBrw1:cAlias)->(OrdKeyCount()) 
   FOR nI := 1 TO nRecno

      OrdKeyGoto( nI )
      cFile1 := ALLTRIM( (oBrw1:cAlias)->PATH1 ) + ALLTRIM( (oBrw1:cAlias)->FILE1 )
      cFile2 := ALLTRIM( (oBrw1:cAlias)->PATH2 ) + ALLTRIM( (oBrw1:cAlias)->FILE2 )
      IF FILE(cFile1)
         IF '' $ (oBrw1:cAlias)->STATUS1 .OR. ;
            'new' $ (oBrw1:cAlias)->STATUS1 
             AADD( aFile, cFile1 )
         ENDIF
      ENDIF
      IF FILE(cFile2)
         IF '' $ (oBrw1:cAlias)->STATUS2 .OR. ; 
            'new' $ (oBrw1:cAlias)->STATUS2 
             AADD( aFile, cFile2 )
         ENDIF
      ENDIF
   NEXT

   MyBackupZip(cPath, aFile)

   MyButt1Visible()   //    

RETURN NIL
/////////////////////////////////////////////////////////////////////////
FUNCTION MyButt1Visible()   //    
   LOCAL cForm := oBrw1:cParentWnd

   // -------     ----------
   SetProperty(cForm, "Sizable"   , .T. ) // NOSIZE
   SetProperty(cForm, "MaxButton" , .T. ) // NOMAXIMIZE
   SetProperty(cForm, "MinButton" , .T. ) // NOMINIMIZE

   //    
   SetProperty(cForm, "oBut_Copy1to2", "Visible", .F.) 
   SetProperty(cForm, "oBut_Copy2to1", "Visible", .F.) 
   SetProperty(cForm, "oBut_Cancel"  , "Visible", .F.) 

   SetProperty(cForm, "oBut_Comp", "Visible", .T.) 
   SetProperty(cForm, "oBut_1to2", "Visible", .T.) 
   SetProperty(cForm, "oBut_2to1", "Visible", .T.) 
   SetProperty(cForm, "oBut_Zip" , "Visible", .T.) 
   SetProperty(cForm, "oBut_Exit", "Visible", .T.) 

RETURN NIL

/////////////////////////////////////////////////////////////////////////
FUNCTION Foot5Size(nAtCol,oBrw)   
   LOCAL nI, nRecno, nVal1 := 0, nVal2 := 0

   SELECT(oBrw:cAlias)
   nRecno := (oBrw:cAlias)->(OrdKeyCount()) 
   FOR nI := 1 TO nRecno
       OrdKeyGoto( nI )
       nVal1 += (oBrw:cAlias)->SIZE1
       nVal2 += (oBrw:cAlias)->SIZE2
   NEXT
   OrdKeyGoto( 1 )

   oBrw1:aColumns[nAtCol]:cFooting := TRANSFORM( nVal1, "@Z 999 999 999 " ) + CRLF + ;
                                      TRANSFORM( nVal2, "@Z 999 999 999 " )
   oBrw1:DrawFooters()

RETURN NIL

/////////////////////////////////////////////////////////////////////////
FUNCTION Foot8Itog(nAtCol,oBrw)   
   LOCAL nI, nRecno, cVal, nVal1 := 0, nVal2 := 0

   SELECT(oBrw:cAlias)
   nRecno := (oBrw:cAlias)->(OrdKeyCount()) 
   FOR nI := 1 TO nRecno
       OrdKeyGoto( nI )
       IF LEN( ALLTRIM( (oBrw1:cAlias)->STATUS1 ) ) > 0
          nVal1 ++
       ENDIF
       IF LEN( ALLTRIM( (oBrw1:cAlias)->STATUS2 ) ) > 0
          nVal2 ++
       ENDIF
   NEXT
   OrdKeyGoto( 1 )

   cVal := IIF( nVal1 > 0, "- "+HB_NtoS(nVal1) + " -", "") + CRLF
   cVal += IIF( nVal2 > 0, "- "+HB_NtoS(nVal2) + " -", "") 

   oBrw1:aColumns[nAtCol]:cFooting := cVal
   oBrw1:DrawFooters()

RETURN NIL
/////////////////////////////////////////////////////////////////////////
#define WM_VSCROLL      277  // 0x0115 
#define SB_PAGEDOWN     3 
#define SB_PAGEUP       2 
#define SB_BOTTOM	7 

FUNCTION MyButtonCopyFile(nCopy, cTitle)
   LOCAL cForm := ThisWindow.Name
   LOCAL nI, nFWidth, nHoBrw, cText, cFileInp, cFileOut
   LOCAL nRecno, nStatus, nDelError, cFileInf1, cFileInf2
   LOCAL cFile, cStr, dFDate, cFTime, cFileLog := PATH_BACKUP 
   
   cFileLog += "copy" + DTOS(DATE()) + "-"+CharRepl( ":", Time(), "-" ) + ".log"

   oBrw1:Enabled( .F. )  //   TBROWSE
   //SetProperty(oBrw1:cParentWnd, oBrw1:cControlName, "Enabled", .F.) 
   //oBrw1:Enabled( .T. )  //   TBROWSE
   SetProperty(cForm, "oBrw1", "Visible", .F.) 

   //    
   SetProperty(cForm, "oBut_Copy1to2", "Visible", .F.) 
   SetProperty(cForm, "oBut_Copy2to1", "Visible", .F.) 
   SetProperty(cForm, "oBut_Cancel"  , "Visible", .F.) 
   //    
   SetProperty(cForm, "oBut_Comp", "Visible", .F.) 
   SetProperty(cForm, "oBut_1to2", "Visible", .F.) 
   SetProperty(cForm, "oBut_2to1", "Visible", .F.) 
   SetProperty(cForm, "oBut_Zip" , "Visible", .F.) 

   nHoBrw  := GetWindowHeight(GetControlHandle( oBrw1:cControlName, cForm)) 
   nFWidth := GetClientWidth( GetFormHandle( cForm ) )

   SetProperty(cForm, "Edit_Memo", "Height" , nHoBrw  ) 
   SetProperty(cForm, "Edit_Memo", "Width"  , nFWidth ) 
   SetProperty(cForm, "Edit_Memo", "Visible", .T. ) 

   cText := CRLF + PADC( "[ "+cTitle+" ]",80,"-") + CRLF + CRLF
   SetProperty(cForm, "Edit_Memo", "Value", cText ) 
   SendMessage( GetControlHandle('Edit_Memo', cForm) , WM_VSCROLL , SB_BOTTOM , 0 ) 

   SELECT(oBrw1:cAlias)
   nRecno := (oBrw1:cAlias)->(OrdKeyCount()) 
   FOR nI := 1 TO nRecno

      OrdKeyGoto( nI )
      IF nCopy == 12
         cFile := ALLTRIM( (oBrw1:cAlias)->FILE1 )
         cFileInp  := ALLTRIM( (oBrw1:cAlias)->PATH1 ) + cFile
         cFileInf1 := "  ( "+DTOC((oBrw1:cAlias)->DATE1)+ " " + (oBrw1:cAlias)->TIME1 + ")"
         cFileOut  := ALLTRIM( (oBrw1:cAlias)->PATH2 ) + cFile
         cFileInf2 := "  ( "+DTOC((oBrw1:cAlias)->DATE2)+ " " + (oBrw1:cAlias)->TIME2 + ")"
         dFDate    := (oBrw1:cAlias)->DATE1 
         cFTime    := (oBrw1:cAlias)->TIME1
      ELSE
         cFile := ALLTRIM( (oBrw1:cAlias)->FILE2 )
         cFileInp  := ALLTRIM( (oBrw1:cAlias)->PATH2 ) + cFile
         cFileInf1 := "  ( "+DTOC((oBrw1:cAlias)->DATE2)+ " " + (oBrw1:cAlias)->TIME2 + ")"
         cFileOut  := ALLTRIM( (oBrw1:cAlias)->PATH1 ) + cFile
         cFileInf2 := "  ( "+DTOC((oBrw1:cAlias)->DATE1)+ " " + (oBrw1:cAlias)->TIME1 + ")"
         dFDate    := (oBrw1:cAlias)->DATE2 
         cFTime    := (oBrw1:cAlias)->TIME2
      ENDIF

      cText += IIF(M->nPubLang == 1, " ", "Copy" ) + cFileInp + cFileInf1 + CRLF
      cText += IIF(M->nPubLang == 1, " ", "to ") + cFileOut + cFileInf2 + CRLF 

      SetProperty(cForm, "Edit_Memo", "Value", cText ) 
      SendMessage( GetControlHandle('Edit_Memo', cForm) , WM_VSCROLL , SB_BOTTOM , 0 ) 

      SetWaitCursor( _HMG_MainHandle )            //   - 
      nDelError := DeleteFile( cFileOut )
      nStatus := hb_FCopy( cFileInp, cFileOut )
      cText += IIF(M->nPubLang == 1, "     : "   , "   delete the file status: ") + HB_NtoS(nDelError) 
      cText += IIF(M->nPubLang == 1, "     : ", "   file copy status: ")+ HB_NtoS(nStatus) + CRLF 
      cStr := DTOC(dFDate) + " " + cFTime
      cText += IIF(M->nPubLang == 1, "       : "   , "   change the date and time of the file: ") + cStr + CRLF
      cText += CRLF
      hb_FSetDateTime( cFileOut, dFDate, cFTime )

      INKEYGUI(100)
      SetArrowCursor( _HMG_MainHandle )             //   - 
   NEXT
   cText += CRLF + IIF(M->nPubLang == 1, " >>   <<", " >> End of processing <<") + CRLF
   SetProperty(cForm, "Edit_Memo", "Value", cText ) 
   SendMessage( GetControlHandle('Edit_Memo', cForm) , WM_VSCROLL , SB_BOTTOM , 0 ) 

   HB_MemoWrit( cFileLog, cText )

   //    
   SetProperty(cForm, "oBut_Exit", "Visible", .T.)  


RETURN NIL
