/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2016 Verchenko Andrey <verchenkoag@gmail.com>
*/

#include "minigui.ch"

MEMVAR oBrw1
//////////////////////////////////////////////////////////////////
//   
FUNCTION SelectHeaders(nRowPix,nColPix,nAt,oBrw)
    LOCAL cForm := oBrw:cParentWnd
    LOCAL nCell := oBrw:nCell    //      
    LOCAL nRPos := oBrw:nRowPos  //     
    LOCAL nClickRow := oBrw:GetTxtRow( nRowPix )
    LOCAL nAtCol := Max( oBrw:nAtCol( nColPix ), 1 ) //   
    LOCAL nVal, nI, nRecno

    //MsgDebug(nRowPix,nColPix,nAt,"/",nCell,nRPos,nClickRow," nAtCol:",nAtCol)
    IF nAtCol == 2  //  2-  -   
       nVal := Forma_SelectCheck(cForm, nRowPix, nColPix,oBrw)
       IF nVal > 0
          SELECT(oBrw:cAlias)
          nRecno := (oBrw:cAlias)->(OrdKeyCount()) 
          FOR nI := 1 TO nRecno
              OrdKeyGoto( nI )
              (oBrw:cAlias)->LCOPY := IIF(nVal == 1, .T., .F.)
          NEXT
          OrdKeyGoto( 1 )
          oBrw:Refresh(.T.)   //    
       ENDIF
    ELSEIF nAtCol == 5  //  5-  -   
       Foot5Size(nAtCol,oBrw)
    ENDIF
    
RETURN NIL

//////////////////////////////////////////////////////////////////
//   
FUNCTION SelectFooters(nRowPix,nColPix,nAt,oBrw)
    LOCAL cForm := oBrw:cParentWnd
    LOCAL nCell := oBrw:nCell    //      
    LOCAL nRPos := oBrw:nRowPos  //    
    LOCAL nClickRow := oBrw:GetTxtRow( nRowPix )
    LOCAL nAtCol := Max( oBrw:nAtCol( nColPix ), 1 )
    LOCAL cRet, nVal, nRecno, nI

    //MsgDebug(nRowPix,nColPix,nAt,"/",nCell,nRPos,nClickRow," nAtCol:",nAtCol)
    IF nAtCol == 2  //  2-  -   
       nVal := Forma_SelectCheck(cForm, nRowPix, nColPix, oBrw)
       IF nVal > 0
          SELECT(oBrw:cAlias)
          nRecno := (oBrw:cAlias)->(OrdKeyCount()) 
          FOR nI := 1 TO nRecno
              OrdKeyGoto( nI )
              (oBrw:cAlias)->LCOPY := IIF(nVal == 1, .T., .F.)
          NEXT
          OrdKeyGoto( 1 )
          oBrw:Refresh(.T.)   //    
       ENDIF
    ELSEIF nAtCol == 5  //  5-  -   
       Foot5Size(nAtCol,oBrw)
    ENDIF

RETURN NIL

////////////////////////////////////////////////////////////////////////////////
FUNCTION Forma_SelectCheck(cForm,nY,nX)
   LOCAL hFont, Font1, Font2, nSelect := -1

   hFont := GetFontHandle( "Font_CM1" ) //  handle  0 
   IF hFont == 0
      DEFINE FONT Font_CM1  FONTNAME "Times New Roman" SIZE 16
   ENDIF
   hFont := GetFontHandle( "Font_CM2" ) //  handle  0 
   IF hFont == 0
       DEFINE FONT Font_CM2  FONTNAME "Comic Sans MS" SIZE 16 BOLD
   ENDIF

   Font1 := GetFontHandle( "Font_CM1" )
   Font2 := GetFontHandle( "Font_CM2" )

   SET MENUSTYLE EXTENDED
   SetMenuBitmapHeight( 32 ) 

   DEFINE CONTEXT MENU OF &cForm
       MENUITEM  " "           ACTION  {|| nSelect := 1 }  FONT Font2 IMAGE "CheckT28"
       MENUITEM  "   "   ACTION  {|| nSelect := 2 }  FONT Font2 IMAGE "CheckF28"
       SEPARATOR                             
       MENUITEM  ""                  ACTION  {|| nSelect := 0 }  FONT Font1 
   END MENU

   //_ShowContextMenu(cForm, nY, nX, .f. ) //      
   _ShowContextMenu(cForm, 0, 0, .f. ) //      

   InkeyGui(10)  // menu    

   DEFINE CONTEXT MENU OF &cForm  //    
   END MENU

   //  
   RELEASE FONT Font_CM1
   RELEASE FONT Font_CM2

RETURN nSelect

///////////////////////////////////////////////////////////////////////////
FUNCTION _ShowContextMenu(ParentFormName, nRow, nCol, lCentered)
   LOCAL xContextMenuParentHandle := 0
   LOCAL aRow := GetCursorPos()
   DEFAULT nRow := 0, nCol := 0, ParentFormName := ""

   If .Not. _IsWindowDefined (ParentFormName)
      xContextMenuParentHandle := _HMG_xContextMenuParentHandle
   else
      xContextMenuParentHandle := GetFormHandle ( ParentFormName )
   Endif
   if xContextMenuParentHandle == 0
      MsgMiniGuiError("Context Menu is not defined. Program terminated")
   endif
   IF lCentered
      //nCol := GetWindowCol(xContextMenuParentHandle) + GetWindowWidth(xContextMenuParentHandle)/2 - 60
      //nRow := GetWindowRow(xContextMenuParentHandle) + GetWindowHeight(xContextMenuParentHandle)/2 - GetTitleHeight() - 5
   ELSEIF nRow == 0 .and. nCol == 0
      nCol := aRow[2]
      nRow := aRow[1]
   ENDIF
   TrackPopupMenu ( _HMG_xContextMenuHandle , nCol , nRow , xContextMenuParentHandle )

RETURN Nil

