/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2016 Verchenko Andrey <verchenkoag@gmail.com>
*/

#include "minigui.ch"
#include "metrocolor.ch"
#include "TSBrowse.ch"

MEMVAR oBrw1, aFontTbr

STATIC aObj2But, aObj3But, nStaticViewRecno := 0
//////////////////////////////////////////////////////////////
FUNCTION TABLE1()
   LOCAL hFont, nFontSize := ModeSizeFont()

   PUBLIC aFontTbr := {}   //     
   PUBLIC oBrw1            //  
   PUBLIC nPubLang         //    1-, 2-english

   M->nPubLang := IniGetLangProg("","", "SetLang" ) //     

   hFont := GetFontHandle( "Font_Tbr1" ) 
   IF hFont == 0
      DEFINE FONT Font_Tbr1  FONTNAME "Times New Roman" SIZE nFontSize-2
   ENDIF
   hFont := GetFontHandle( "Font_Tbr2" ) 
   IF hFont == 0
       DEFINE FONT Font_Tbr2  FONTNAME "Comic Sans MS" SIZE nFontSize BOLD
   ENDIF
   hFont := GetFontHandle( "Font_Tbr3" ) 
   IF hFont == 0
       DEFINE FONT Font_Tbr3  FONTNAME "Comic Sans MS" SIZE nFontSize BOLD
   ENDIF
   hFont := GetFontHandle( "Font_Tbr4" ) 
   IF hFont == 0
       DEFINE FONT Font_Tbr4  FONTNAME "Arial" SIZE nFontSize-3 ITALIC
   ENDIF
   hFont := GetFontHandle( "Font_Tbr5" ) 
   IF hFont == 0
       DEFINE FONT Font_Tbr5  FONTNAME "Arial" SIZE nFontSize ITALIC
   ENDIF
   hFont := GetFontHandle( "Font_Tbr6" ) 
   IF hFont == 0
       DEFINE FONT Font_Tbr6  FONTNAME "Tahona" SIZE nFontSize-5
   ENDIF
   //
   AAdd( M->aFontTbr, GetFontHandle( "Font_Tbr1" ) )
   AAdd( M->aFontTbr, GetFontHandle( "Font_Tbr2" ) )
   AAdd( M->aFontTbr, GetFontHandle( "Font_Tbr3" ) )
   AAdd( M->aFontTbr, GetFontHandle( "Font_Tbr4" ) )
   AAdd( M->aFontTbr, GetFontHandle( "Font_Tbr5" ) )
   AAdd( M->aFontTbr, GetFontHandle( "Font_Tbr6" ) )

   FORM_TABLE1()  //    

   IniSetLangProg("","", "SetLang", M->nPubLang ) //     

   //  
   RELEASE FONT Font_Tbr1
   RELEASE FONT Font_Tbr2
   RELEASE FONT Font_Tbr3
   RELEASE FONT Font_Tbr4
   RELEASE FONT Font_Tbr5
   RELEASE FONT Font_Tbr6
   RELEASE aFontTbr
   RELEASE oBrw1       //  
   RELEASE nPubLang    //   

RETURN NIL

//////////////////////////////////////////////////////////////
FUNCTION FORM_TABLE1()
   LOCAL nFWidth, nFHeight, aBackColor, cTitle, cIcon
   LOCAL hWnd, nJ, aDim[3], nLbl0, nI, nLblCol, cStatusBar
   LOCAL cFont := "Tahona", nFontSize := ModeSizeFont()
   LOCAL nColIco, nHStBar, nHLabel, aBackColorTbr, aRowColWin, nTableWidth
   LOCAL aLangsR := { "", "", "", "" , "" }
   LOCAL aLangsE := { "Russian", "English"   , "Ukrainian" , "Byelorussian", "Kazakh"    }
   LOCAL aFlags  := { "FLAG_RU", "FLAG_EN"   , "FLAG_UK"   , "FLAG_BYR"    , "FLAG_KZN"  }
   LOCAL aLangs := {}, cAlias := ALIAS()

   cTitle     := GetProperty("Form_Main","Title"     )
   cIcon      := 'MG128' 
   aBackColor := GetProperty("Form_Main","BackColor" )
   aBackColorTbr := { 165,227,240 }
   cStatusBar := GetProperty("Form_Main","Label_StatusBar", "Value" )
   nHStBar  := 70 
   nFWidth  := GetDesktopWidth() * 0.7
   nFHeight := ( GetDesktopHeight() - GetTaskBarHeight() ) - 10

   SET FONT TO cFont , nFontSize 

   DEFINE WINDOW Forma_1 AT 0,0          ;
       WIDTH nFWidth HEIGHT nFHeight     ;
       MINWIDTH 780 MINHEIGHT 500        ;
       WINDOWTYPE STANDARD TOPMOST       ;
       TITLE cTitle                      ; 
       ICON cIcon                        ;
       BACKCOLOR aBackColor              ;
       ON SIZE { || ResizeForma1() }     ;
       ON MAXIMIZE { || ResizeForma1() } ;
       ON INIT { || aRowColWin := IniGetPosWindow(), MyTitleFormLang() ,;
                    SetProperty( "Forma_1", "Topmost", .F.)            ,;
                    IIF( LEN(aRowColWin) > 0, NIL , Forma_1.Width := nTableWidth ) ,;
                    TblFocus()  }        ;
       ON RELEASE { || IniSetPosWindow() } 

       hWnd := GetFormHandle(_HMG_ThisFormName)
       nFWidth  := GetClientWidth( hWnd )
       nFHeight := GetClientHeight( hWnd )
       
       DRAW ICON IN WINDOW Forma_1 AT 10, 10 PICTURE 'MG128' WIDTH 128 HEIGHT 128 COLOR aBackColor
       
       nColIco := 128 
       nLblCol := nColIco + 10*2
       nLbl0 := 128 + 10*2
       nJ := nLbl0/3 
       @ 0, nLblCol LABEL Label_0 WIDTH nFWidth-nLblCol HEIGHT nLbl0-nJ VALUE '' TRANSPARENT 
       
       @ 0, nLblCol LABEL Label_1 WIDTH nFWidth-nLblCol HEIGHT nJ VALUE '' ;
          FONT "Comic Sans MS" SIZE nFontSize*1.3 BOLD  CENTERALIGN ;
          FONTCOLOR WHITE BACKCOLOR aBackColor  VCENTERALIGN
       @ nJ*1, nLblCol LABEL Label_2 WIDTH nFWidth-nLblCol HEIGHT nJ VALUE '' ;
          FONT "Comic Sans MS" SIZE nFontSize*1.3 BOLD  CENTERALIGN ;
          FONTCOLOR WHITE BACKCOLOR aBackColor  VCENTERALIGN
       @ nJ*2, nLblCol LABEL Label_3 VALUE cStatusBar WIDTH nFWidth-nLblCol HEIGHT nJ ;
          FONT "Comic Sans MS" SIZE 12 BOLD FONTCOLOR WHITE TRANSPARENT ;
          CENTERALIGN VCENTERALIGN ;
          ON CLICK MsgAbout(.T.)  ;
          ON MOUSEHOVER MarkerLabel(.T., RED   , aBackcolor, 14 ) ;
          ON MOUSELEAVE MarkerLabel(.F., WHITE , aBackcolor, 12 ) 

       @ 10, nFWidth - 30 IMAGE Image_1 PICTURE aFlags[M->nPubLang] WIDTH 22 HEIGHT 20 ;
         STRETCH TRANSPARENT BACKGROUNDCOLOR aBackColor ;
         OnMouseHover RC_CURSOR( "MINIGUI_FINGER" )     ;
         ACTION { ||  Forma_1.ComboEx_1.Col := GetClientWidth( hWnd ) - 280 ,;
                      Forma_1.ComboEx_1.Show, ; 
                      SetFocus(GetControlHandle( "ComboEx_1", "Forma_1" )), ; 
                      _PushKey ( VK_F4 ) } 

       FOR nI := 1 TO Len( aLangsR )
          AAdd( aLangs, aLangsR[ nI ] + " (" + aLangsE[ nI ] + ")" )
       NEXT
       @ 10, nFWidth - 300 COMBOBOXEX ComboEx_1 ;
          WIDTH 340 HEIGHT 200 ;
          ITEMS aLangs         ;
          VALUE M->nPubLang    ;
          IMAGE aFlags         ;
          TOOLTIP '  / Select lang DBF' INVISIBLE ;
          ON LISTCLOSE Forma_1.ComboEx_1.Hide ;
          ON CHANGE { || M->nPubLang := Forma_1.ComboEx_1.Value, ;
                         Forma_1.ComboEx_1.Hide, Forma_1.Image_1.Hide ,;
                         Forma_1.Image_1.Picture := aFlags[M->nPubLang],;
                         Forma_1.Image_1.Col := GetClientWidth( GetFormHandle("Forma_1") ) - 30, ;
                         MyTitleFormLang(), MyTitleSHLang() ,;
                         Forma_1.Image_1.Show, Forma_1.Image_1.Setfocus } 

       nHLabel := nLbl0
       SELECT(cAlias)
       goto TOP
       DEFINE TBROWSE oBrw1        ; 
              AT     nHLabel,0     ; 
              WIDTH  nFWidth  ; 
              HEIGHT nFHeight - nHLabel - nHStBar ;
              ON CHANGE  { || ChangeTable() } ;
              ON GOTFOCUS ChangeTable() ;
              BACKCOLOR aBackColorTbr ;
              CELL         

       END TBROWSE  
       nTableWidth := MyCreateTable()  //  
       MyCreateTableMenu(cFont, nFontSize) //   

       @ nHLabel, 0 EDITBOX Edit_Memo         ;
          WIDTH nFWidth HEIGHT nFHeight - nHLabel - nHStBar ;
          VALUE ""                          ;
          BACKCOLOR WHITE                   ;
          FONTCOLOR aBackColor              ;
          SIZE nFontSize-2                  ;
          MAXLENGTH 1200 NOHSCROLL READONLY INVISIBLE

       //    nHStBar   MyButtonBar()
       @ nFHeight - nHStBar, 0 LABEL Label_StatusBar VALUE "" ;
          WIDTH nFWidth HEIGHT nHStBar FONTCOLOR WHITE TRANSPARENT 

       MyButtonBar(.F.) //    / button at the bottom of the table 

//       ON KEY ESCAPE OF Forma_1 ACTION ThisWindow.Release

   END WINDOW

   CENTER WINDOW Forma_1
   ACTIVATE WINDOW Forma_1

RETURN NIL

//////////////////////////////////////////////////////////////////
FUNCTION  MyTitleFormLang()
   LOCAL cForm := ThisWindow.Name
   LOCAL aDim[2]

   IF M->nPubLang == 1
      aDim[1] := '       '
      aDim[2] := ' Harbour'  
   ELSE
      aDim[1] := 'Compare and merge two project files directory'   
      aDim[2] := 'for Harbour'  
   ENDIF

   SetProperty(cForm, "Label_1", "Value", aDim[1] ) 
   SetProperty(cForm, "Label_2", "Value", aDim[2] ) 

RETURN aDim

//////////////////////////////////////////////////////////////////
FUNCTION ResizeForma1(lButton)
    LOCAL cForm := _HMG_ThisFormName
    LOCAL hWnd := GetFormHandle(cForm)
    LOCAL actpos:={0,0,0,0}, w, h, nWLbl 
    LOCAL nHStBar := GetWindowHeight(GetControlHandle("Label_StatusBar", cForm)) //  StatusBar 
    LOCAL nFWidth  := GetClientWidth( GetFormHandle( cForm ) )
    LOCAL nFHeight := GetClientHeight( GetFormHandle( cForm ) )
    DEFAULT lButton := .T.

    //oBrw1:Move( oBrw1:nLeft ,oBrw1:nTop , GetClientWidth(hWnd), ;
    //                                   GetClientHeight(hWnd) - oBrw1:nTop, .t.)
    GetClientRect(hWnd, actpos) 
    w := actpos[3]-actpos[1] 
    h := actpos[4]-actpos[2] - oBrw1:nTop - nHStBar

    IF w !=0 .and. h != 0 
       nWLbl := GetProperty(cForm, "Label_0", "Col" )
       SetProperty(cForm, "Label_0", "Width", nFWidth - nWLbl ) 
       SetProperty(cForm, "Label_1", "Width", nFWidth - nWLbl ) 
       SetProperty(cForm, "Label_2", "Width", nFWidth - nWLbl ) 
       SetProperty(cForm, "Label_3", "Width", nFWidth - nWLbl ) 
       SetProperty(cForm, "Image_1", "Col"  , nFWidth - 30    ) 

       SetProperty(oBrw1:cParentWnd, oBrw1:cControlName, "Enabled", .F.) 
       _SetControlHeight( oBrw1:cControlName, oBrw1:cParentWnd, h) 
       _SetControlWidth ( oBrw1:cControlName, oBrw1:cParentWnd, w) 
       oBrw1:Paint()  //     
       SetProperty(oBrw1:cParentWnd, oBrw1:cControlName, "Enabled", .T.) 
       oBrw1:Refresh(.T.)  //    
       MyButtonBar(.T.)    //     
    Endif 
    
    TblFocus() 

    Return Nil 

////////////////////////////////////////////////////////////
STATIC FUNCTION MyCreateTable()
    LOCAL cForm := ThisWindow.Name
    LOCAL hWnd := GetFormHandle( _HMG_ThisFormName )
    LOCAL nWinWidth := GetClientWidth(hWnd)
    LOCAL hFont, nTxtWidth, nNumberLines := 2
    LOCAL nI, aHead, nBrw1Width, cStroka, aColor
    LOCAL cAlias := Alias(), nFontSize, aFontGet
    LOCAL cToolTip, cRunTT 

    IF M->nPubLang == 1
       aHead := { " "  , " " , " " , "" , "", ""  }
       cToolTip := " /  . :"
       cRunTT   := "     ..."
    ELSE
       aHead := { " Files"  , " Size"   , " Date" , "Time"  , "Status", "Run"     }
       cToolTip := "Remove / put a label. Line:"
       cRunTT   := "Starting the program with these files ..."
    ENDIF
 
    //  ---------------  TBROWSE   -----------------------------
    oBrw1:ChangeFont( M->aFontTbr[ 1 ], , 1 )   // 1-cells font
    oBrw1:ChangeFont( M->aFontTbr[ 2 ], , 2 )   // 2-header font
    oBrw1:ChangeFont( M->aFontTbr[ 3 ], , 3 )   // 3-footer font
    oBrw1:ChangeFont( M->aFontTbr[ 4 ], , 4 )   // 4-special header font
    oBrw1:ChangeFont( M->aFontTbr[ 5 ], , 5 )   // 5-edition font

    nFontSize := 10
    hFont := oBrw1:hFont     //     
    If hFont != Nil
       aFontGet := GetFontParam(hFont)
       nFontSize := aFontGet[2]
    ENDIF
  
    // --------------------     ------------------------------
    aColor := ListColorTable()    

    // --------------------     ------------------------------
    //       
    nTxtWidth := GetTextWidth( NIL, "00", hFont ) + 10  // +10  
    nBrw1Width := nTxtWidth                    //    
     ADD COLUMN TO oBrw1 HEADER "" ;
         DATA {|| TRANSFORM( (cAlias)->NN, "@Z 99999" ) } ;
         SIZE nTxtWidth PIXELS ;
         ALIGN DT_CENTER,DT_CENTER,DT_CENTER   // cells, header, footer

     //  2-  
     nTxtWidth := 48 
     nBrw1Width += nTxtWidth                          //    
     ADD COLUMN TO oBrw1 HEADER ""             ;
         SIZE nTxtWidth                        ;
         DATA FIELDWBLOCK("LCOPY", select(cAlias)) ;
         ALIGN DT_CENTER, DT_VERT              ;      // Cells centered, Header Vertical
         CHECKBOX                              ;      // Editing with Check Box
         EDITABLE        
         // DATA {|| (cAlias)->LCOPY  }    ; //    -   !
         //    -> Button_run.prg
         oBrw1:aColumns[2]:bPostEdit := { |uVal,oBrw,lApp| MyCheckBox2(uVal,oBrw,lApp) } 
         oBrw1:aColumns[2]:uBmpHead  := { || LoadImage( "CheckF28" ) }
         oBrw1:aColumns[2]:nHAlign   := nMakeLong( DT_CENTER, DT_CENTER )

     //  3-   
     nTxtWidth := 48 
     nBrw1Width += nTxtWidth                    //    
     ADD COLUMN TO oBrw1 HEADER ""  ;
         DATA { || (cAlias)->FBMP } ;
         SIZE nTxtWidth BITMAP      ;
         ALIGN DT_CENTER,DT_CENTER,DT_CENTER    // cells, header, footer
         oBrw1:aColumns[3]:uBmpCell := {|| (cAlias)->FBMP }
         oBrw1:aColumns[3]:bData :=  {||Nil}
         oBrw1:aColumns[3]:cData := '{||Nil}'
         oBrw1:aColumns[3]:nAlign := nMakeLong( DT_CENTER, DT_CENTER )

     //  4-  
     cStroka := REPLICATE("a", 30 )
     nTxtWidth := GetTextWidth( NIL, cStroka, hFont ) 
     nBrw1Width += nTxtWidth                       //    
     ADD COLUMN TO oBrw1 HEADER aHead[1]       ;   // ""
         SIZE nTxtWidth                        ;
         ALIGN DT_LEFT,DT_CENTER,DT_LEFT       ;   // cells, header, footer
         DATA {|| (cAlias)->DIR1 + (cAlias)->FILE1  + CRLF + ;
                  (cAlias)->DIR2 + (cAlias)->FILE2   }    // multi-line feature on cells

     //  5-  
     cStroka := REPLICATE("0", 14 )
     nTxtWidth := GetTextWidth( NIL, cStroka, hFont ) 
     nBrw1Width += nTxtWidth                       //    
     ADD COLUMN TO oBrw1 HEADER aHead[2]        ;  // " ()"
         SIZE nTxtWidth                         ;
         ALIGN DT_RIGHT,DT_CENTER,DT_RIGHT      ;   // cells, header, footer
         DATA {|| TRANSFORM( (cAlias)->SIZE1, "@Z 999 999 999" ) + CRLF + ;
                  TRANSFORM( (cAlias)->SIZE2, "@Z 999 999 999" )   }    // multi-line feature on cells

     //  6-  
     cStroka := "0990990990"
     nTxtWidth := GetTextWidth( NIL, cStroka, hFont ) 
     nBrw1Width += nTxtWidth                       //    
     ADD COLUMN TO oBrw1 HEADER aHead[3]        ;  // ""
         SIZE nTxtWidth                         ;
         ALIGN DT_CENTER,DT_CENTER,DT_RIGHT     ;   // cells, header, footer
         DATA {|| TRANSFORM( (cAlias)->DATE1, "99.99.99" ) + CRLF + ;
                  TRANSFORM( (cAlias)->DATE2, "99.99.99" )   }    // multi-line feature on cells

     //  7-  
     cStroka := "0990990990"
     nTxtWidth := GetTextWidth( NIL, cStroka, hFont ) 
     nBrw1Width += nTxtWidth                    //    
     ADD COLUMN TO oBrw1 HEADER aHead[4]    ;   // ""
         SIZE nTxtWidth                     ;
         ALIGN DT_RIGHT,DT_CENTER,DT_RIGHT  ;   // cells, header, footer
         DATA {|| (cAlias)->TIME1 + CRLF +  ;
                  (cAlias)->TIME2   }           // multi-line feature on cells

     //  8-  
     cStroka := "00"
     nTxtWidth := GetTextWidth( NIL, cStroka, hFont ) 
     nBrw1Width += nTxtWidth                     //    
     ADD COLUMN TO oBrw1 HEADER aHead[5]     ;   // ""
         SIZE nTxtWidth                      ;
         ALIGN DT_CENTER,DT_CENTER,DT_RIGHT  ;   // cells, header, footer
         DATA {|| (cAlias)->STATUS1 + CRLF + ;
                  (cAlias)->STATUS2   }           // multi-line feature on cells

     //  9-  
     cStroka := "0WinMerge0"
     nTxtWidth := GetTextWidth( NIL, cStroka, hFont ) 
     nBrw1Width += nTxtWidth                     //    
     ADD COLUMN TO oBrw1 HEADER aHead[6]     ;   //""
         SIZE nTxtWidth                      ;
         ALIGN DT_CENTER,DT_CENTER,DT_RIGHT  ;   // cells, header, footer
         DATA {|| (cAlias)->RUNFUNC  }       ;
         EDITABLE                             
         oBrw1:aColumns[9]:bPrevEdit := { || RunCompare(), FALSE }  //   
         //oBrw1:aColumns[2]:bPostEdit := {|| ????() }              //   

    //MsgDebug("    =",nBrw1Width)

    // --------------------     ----------------------------
     Add Super Header To oBrw1 From Column 1 To Column 9 ;
         Color CLR_BLACK, {  aColor[2], CLR_YELLOW } ;
         Title MyTitleSHeader() 3DLook BITMAP LoadImage("Cnfg84") HORZ DT_LEFT

     //     / We hang SuperHeader treatment table
     For nI := 1 To oBrw1:nColCount()
        //oBrw1:aColumns[nI]:bHLClicked:={|nRowPix, nColPix, nAt|if(nRowPix>oBrw1:nHeightSuper,,FunSHeader(oBrw1))}
        oBrw1:aColumns[nI]:bHLClicked:={|nRowPix, nColPix, nAt,oBrw|if(nRowPix>oBrw:nHeightSuper,,FunSHeader(oBrw))} 
     Next 

     oBrw1:lNoChangeOrd := .T.  //    
     oBrw1:nColOrder := 0       //     

     // ---------   CHECKBOX    ---------
     oBrw1:aCheck   := { LoadImage("CheckT28"), LoadImage("CheckF28") }

     //oBrw1:lCellBrw := .F.     //     / Marker on the entire table
     // -------------- Fixed cursor ,   ---------
     For nI := 1 To oBrw1:nColCount()
        oBrw1:aColumns[nI]:lFixLite := TRUE
     Next
  
     //  :  /   
     oBrw1:SetColor( { 6 }, { { |a,b,c| IF( c:nCell == b, aColor[6] ,;  
                                  { aColor[27], aColor[28] })  }   } )            

     //     h_tbrowse.prg
     //oBrw1:lNoGrayBar  := .t.  //    
     //oBrw1:nAdjColumn  := 3    //        
     //oBrw1:nHeightCell += IIF(LargeFonts(),20,16) + 60   //                                                                  
     oBrw1:nHeightCell := nNumberLines * nFontSize         //   
  
     oBrw1:nHeightSuper := 90  //   (  )
  
     oBrw1:nHeightHead := nFontSize*2.3    //        
     oBrw1:lNoHScroll  := .T.  //   
  
     oBrw1:lFooting := .T.     //  
     oBrw1:lDrawFooters := .T. //   
     oBrw1:nHeightFoot  := nFontSize*2.3 //   
     oBrw1:DrawFooters()       //   
  
     oBrw1:nFreeze     := 1     //  
     oBrw1:lLockFreeze := .T.   //      
     
     //   
     //oBrw1:aColumns[4]:cFooting := { || ": 0/0  " }
  
     oBrw1:ResetVScroll()      //   

     //    .   
     oBrw1:bChange := { |oBrw| ChangeTable(oBrw) }  

     //  ---------------  TBROWSE   -----------------------------
     oBrw1:ChangeFont( M->aFontTbr[ 1 ], , 1 )   // 1-cells font
     oBrw1:ChangeFont( M->aFontTbr[ 2 ], , 2 )   // 2-header font
     oBrw1:ChangeFont( M->aFontTbr[ 3 ], , 3 )   // 3-footer font
     oBrw1:ChangeFont( M->aFontTbr[ 4 ], , 4 )   // 4-special header font
     oBrw1:ChangeFont( M->aFontTbr[ 5 ], , 5 )   // 5-edition font
    
     IF oBrw1:nLen == 0  //  ,    
        MsgDebug("  TBROWSE == 0 !","DbSetFilter=",DBFILTER())
     ELSE
        //MsgDebug("  TBROWSE == ", oBrw9:nLen ,"DbSetFilter=",DBFILTER())
     ENDIF
  
     //oBrw1:bKeyDown := { | nKey | MyKeyAction3(nKey,oBrw9, ThisWindow.Name, 0), lOk := nKey != VK_ESCAPE }
     //oBrw1:bLDblClick:= { || MyAction3(oBrw9, ThisWindow.Name, 0) } //      
  
     oBrw1:Refresh(.T.)
     
     //oBrw1:nAt := 5       //    5 
     oBrw1:nCell := 4       //   

     // ----------        ----------------
     For nI := 2 To oBrw1:nColCount()
        //        
        oBrw1:aColumns[ nI ]:bHLClicked := {|nRowPix,nColPix,nAt,oBrw| SelectHeaders(nRowPix,nColPix,nAt,oBrw) } 
        oBrw1:aColumns[ nI ]:bHRClicked := {|nRowPix,nColPix,nAt,oBrw| SelectHeaders(nRowPix,nColPix,nAt,oBrw) } 
        //        
        oBrw1:aColumns[ nI ]:bFLClicked := {|nRowPix,nColPix,nAt,oBrw| SelectFooters(nRowPix,nColPix,nAt,oBrw) } 
        oBrw1:aColumns[ nI ]:bFRClicked := {|nRowPix,nColPix,nAt,oBrw| SelectFooters(nRowPix,nColPix,nAt,oBrw) } 
     Next

     // ----   ( ) -----------------------
     oBrw1:aColumns[5]:hFontFoot := M->aFontTbr[6] //    / Font size basement
     oBrw1:aColumns[8]:hFontFoot := M->aFontTbr[6] //    / Font size basement
     oBrw1:aColumns[8]:nFAlign   := DT_CENTER
  
     SetNoHoles( oBrw1 ) //      

     // ----     -----------------------
     //oBrw1:cToolTip := {|oBr,nCol,nRow| "My TBrowse tooltip. Col ="+str(nCol,3)+" Row ="+str(nRow,3) }  
     //aEval(oBrw1:aColumns, {|oCol| oCol:cToolTip := {|oBr,nCol,nRow| "My column tooltip. Col ="+str(nCol,3)+" Row ="+str(nRow,3) } }) 

     //oBrw1:cToolTip := {|oBr,nCol,nRow| "My TBrowse tooltip. Col ="+str(nCol,3)+" Row ="+str(nRow,3) }  
     oBrw1:cToolTip := {|oBr,nCol,nRow| IIF( nCol==2, cToolTip + " "+HB_NtoS(nRow),;
                                             IIF( nCol==9, cRunTT, "" ) ) }

     //MsgDebug("    =",nBrw1Width)

RETURN nBrw1Width

////////////////////////////////////////////////////////////
STATIC FUNCTION MyCreateTableMenu(cFont, nFontSize)
    LOCAL cForm := ThisWindow.Name
    LOCAL cMenuFont, cScreen, aTableFont
  
     cMenuFont := ": " + cFont + "  : " + HB_NtoS(nFontSize)
     cScreen := IIF(LargeFonts()," .. "," ... ") + "(" + HB_NtoS(GetDesktopWidth())+"x"+HB_NtoS(GetDesktopHeight()) + ")"
  
     aTableFont := LoadTbrwFonts(oBrw1) //   
     //     -   TBROWSE
     DEFINE CONTEXT MENU CONTROL oBrw1
         //MENUITEM cCaption ACTION bAction NAME cName IMAGE cImage
         MENUITEM "File open 1: "   ACTION { || RunFile(1)  }  NAME MYNAMEOPENFILE1 
         MENUITEM "File open 2: "   ACTION { || RunFile(2)  }  NAME MYNAMEOPENFILE2 
         SEPARATOR
         MENUITEM ": " + ThisWindow.Name         ACTION { || MsgInfo(": " + ThisWindow.Name) }
         MENUITEM ": " + cScreen                 ACTION { || MsgInfo(cScreen)    }
         MENUITEM cMenuFont + " /  :"     ACTION { || TableInfoFont(cMenuFont,aTableFont) }
         MENUITEM ":  "          ACTION { || TableInfoSuperHeader(oBrw1) }  
         MENUITEM ":   "           ACTION { || TableInfoSize(oBrw1) }
         MENUITEM ":   "      ACTION { || TableInfoCell(oBrw1) }  
     END MENU

RETURN NIL

////////////////////////////////////////////////////////////
STATIC FUNCTION ChangeTable()
   LOCAL cVal, nLen, cLen, cText
   LOCAL cForm := oBrw1:cParentWnd 
   LOCAL cCaption1, cCaption2

   //oBrw1:nAt -   
   //oBrw1:nCell -   
   //oBrw1:nLen -  -   

   cVal := HB_NToS( (oBrw1:cAlias)->(OrdKeyNo()) ) 
   nLen := (oBrw1:cAlias)->(OrdKeyCount())  
   cLen := HB_NToS( nLen )

   //      TBROWSE 
   //  DEFINE CONTEXT MENU CONTROL oBrw1
   //    MenuCaptionSet( cName , cForm , cCaption )

   IF nStaticViewRecno # 0  //    -  

      cCaption1 := "File open 1: " + ALLTRIM((oBrw1:cAlias)->PATH1) + ALLTRIM((oBrw1:cAlias)->FILE1)
      cCaption2 := "File open 2: " + ALLTRIM((oBrw1:cAlias)->PATH2) + ALLTRIM((oBrw1:cAlias)->FILE2)
      MenuCaptionSet( "MYNAMEOPENFILE1" , cForm , cCaption1 )
      MenuCaptionSet( "MYNAMEOPENFILE2" , cForm , cCaption2 )

      oBrw1:aColumns[1]:cFooting := { || ALLTRIM(Transform( nLen, "9 999" ))  }
      cText := IIF( M->nPubLang == 1, " : ", " Recno: ")
      oBrw1:aColumns[4]:cFooting := { || cText + cVal + "/" + cLen }
      oBrw1:DrawFooters()       //   
      TblFocus() 
   ENDIF
   
   RETURN Nil

/////////////////////////////////////////////////////////////////////////////////
Function MenuCaptionSet( ItemName , FormName, Caption ) 

    _SetMenuItemCaption( ItemName , FormName, Caption )

    RETURN Nil
  
/////////////////////////////////////////////////////////////////////////////////
STATIC FUNCTION TblFocus()  
   DoMethod(oBrw1:cParentWnd, oBrw1:cControlName, "SetFocus")
   RETURN NIL

/////////////////////////////////////////////////////////////////////////////////
//    Button ,,  .. 
STATIC FUNCTION ListColorTable()          //   (.)
   LOCAL aBackTbr := { 165,227,240 }      //    
   LOCAL aBackUpWin := GetProperty("Forma_1", "BackColor" )    //   
   LOCAL nHeadColor1 := MyRGB( aBackUpWin )
   LOCAL nHeadColor2 := MyRGB( { 48, 29, 26 } )  // - 
   LOCAL aHeadColor := YELLOW  // "__"
   LOCAL aFootColor := YELLOW  // "__"
   LOCAL aColor[30]

   // --------------------     ------------------------------
   M->oBrw1:SetColor( { 1}, { { || CLR_BLACK                            } } ) // 1 ,                                  
   M->oBrw1:SetColor( { 2}, { { || MyRGB(aBackTbr)                      } } ) // 2 ,                                    
   M->oBrw1:SetColor( { 3}, { { || MyRGB(aHeadColor)                    } } ) // 3 ,                                     
   M->oBrw1:SetColor( { 4}, { { || { nHeadColor1, nHeadColor2 }         } } ) // 4 ,   
   M->oBrw1:SetColor( { 5}, { { || CLR_BLACK                            } } ) // 5 ,  ,                  
   M->oBrw1:SetColor( { 6}, { { || { 4915199,255}                       } } ) // 6 ,                                            
   M->oBrw1:SetColor( { 7}, { { || CLR_RED                              } } ) // 7 ,                               
   M->oBrw1:SetColor( { 8}, { { || CLR_YELLOW                           } } ) // 8 ,                                 
   M->oBrw1:SetColor( { 9}, { { || MyRGB(aFootColor)                    } } ) // 9 ,                                   
   M->oBrw1:SetColor( {10}, { { || { nHeadColor1, nHeadColor2 }         } } ) // 10,                                     
   M->oBrw1:SetColor( {11}, { { || CLR_GRAY                             } } ) // 11,    (selected cell no focused)
   M->oBrw1:SetColor( {12}, { { || { RGB(255,255,74), RGB(240,240,0) }  } } ) // 12,    (selected cell no focused)   
   M->oBrw1:SetColor( {13}, { { || CLR_HRED                             } } ) // 13,    
   M->oBrw1:SetColor( {14}, { { || { nHeadColor1, nHeadColor2 }         } } ) // 14,      
   M->oBrw1:SetColor( {15}, { { || CLR_GRAY                             } } ) // 15,     
   M->oBrw1:SetColor( {16}, { { || {  CLR_WHITE, nHeadColor1 }          } } ) // 16,                                    
   M->oBrw1:SetColor( {17}, { { || CLR_RED                              } } ) // 17,  
   //     - specialselector header background color
   //oBrw1:nClrSelectorHdBack := CLR_HMAGENTA

   // .   
   aColor[  1 ] := CLR_BLACK                // 1 ,                                  
   aColor[  2 ] := MyRGB(aBackTbr)          // 2 ,                                    
   aColor[  6 ] := { 4915199,255}           // 6 ,                                            
   //  :  /   
   aColor[ 27 ] := Rgb( 255, 192, 160 )
   aColor[ 28 ] := Rgb( 255, 226, 0 )             
   //       
   aColor[ 29 ] := nHeadColor1              // 29,                                      
   aColor[ 30 ] := CLR_BLUE                 // 30,    

   RETURN aColor
           
///////////////////////////////////////////////////////////////////
FUNCTION MyButtonBar(lHideShow)  // buttons 
   LOCAL cForm := ThisWindow.Name
   LOCAL hWnd  := GetFormHandle(cForm)
   LOCAL nWinWidth, nWinHeight, nWButt, nHButt, nHStBar
   LOCAL nI, cObject, aCapt, nBeetwButt, nRow, aCol[6]
   LOCAL cFont := "Tahona", nFSize := ModeSizeFont()-2
   LOCAL aFColor := WHITE, aF2Color := BLACK  // .  
   LOCAL aButtShow
   DEFAULT lHideShow := .F.
   
   //     
   nWinWidth  := GetClientWidth(hWnd)
   nWinHeight := GetClientHeight(hWnd)

   nHStBar := GetProperty( cForm, "Label_StatusBar", "Height" ) 

   nWButt := 210         //   
   nHButt := nHStBar-10  //   
   nRow   := nWinHeight - nHStBar + 5  //   

   IF M->nPubLang == 1
      aCapt := { ""  , ""  , ""  , "" , ""  }
   ELSE
      aCapt := { "Compare"   , "Filter"  , "Filter"  , "Backup", "Exit"   }
   ENDIF

   nBeetwButt := INT( ( nWinWidth - nWButt*LEN(aCapt) ) / (LEN(aCapt)+1) )
   //    
   FOR nI := 1 TO LEN(aCapt)
      aCol[nI] := nBeetwButt*nI + nWButt*(nI-1)
   NEXT

IF !lHideShow    //      

   aObj2But := {}
   //   |  1   |  2 |   3    |  4   |  5   |   6    |  7  |  8   |   9  |  10   | 11 |    12                 | 13|14 | 15| 16| 17
   FOR nI := 1 TO LEN(aCapt)
      AADD( aObj2But, {"oBut_?",nRow,aCol[nI],nWButt,nHButt,aCapt[nI],"4x1","4x2",nFSize,aFColor, {} ,{|| ThisWindow.Release },'',.F.,.F.,.F.,.F. } )
   NEXT
   // ----------------------
   aObj2But[1, 1] := "oBut_Comp"              
   aObj2But[1, 7] := "iComp48x1"              
   aObj2But[1, 8] := "iComp48x2"              
   aObj2But[1,11] := COLOR_DARK_BLUE
   aObj2But[1,12] := { || nStaticViewRecno := MyButtonRun1() ,;
                          IIF( nStaticViewRecno == 1, aObj2But[2,17] := .F., ) ,;
                          IIF( nStaticViewRecno == 1, aObj2But[3,17] := .F., ) ,;
                          IIF( nStaticViewRecno == 1, aObj2But[4,17] := .F., ) ,;
                          TblFocus()  } 
                   //  nStaticViewRecno == 1 -  ChangeTable()
                   //   " " 
   aObj2But[1,13] := '    1   2'   // 
   aObj2But[1,15] := .F.  //                    
   aObj2But[1,16] := .T.  //  BOLD                  
   // ----------------------
   aObj2But[2, 1] := "oBut_1to2"              
   aObj2But[2, 7] := "iCopy12x48x1"              
   aObj2But[2, 8] := "iCopy12x48x2"              
   aObj2But[2,11] := COLOR_BRIGHT_PURPLE
   aObj2But[2,12] := { || MyButtonRun2(), TblFocus()   }
   aObj2But[2,13] := '      1   2'   // 
   aObj2But[2,16] := .T.  //  BOLD                  
   aObj2But[2,17] := .T.   // F-   (INVISIBLE)                 
   // ----------------------
   aObj2But[3, 1] := "oBut_2to1"              
   aObj2But[3, 7] := "iCopy21x48x1"              
   aObj2But[3, 8] := "iCopy21x48x2"              
   aObj2But[3,11] := COLOR_YELLOW_METRO
   aObj2But[3,12] := { || MyButtonRun3(), TblFocus()   } 
   aObj2But[3,13] := '      2   1'   // 
   aObj2But[3,16] := .T.  //  BOLD                  
   aObj2But[3,17] := .T.   // F-   (INVISIBLE)                 
   // ----------------------
   aObj2But[4, 1] := "oBut_Zip"              
   aObj2But[4, 7] := "iZip48x1"              
   aObj2But[4, 8] := "iZip48x2"              
   aObj2But[4,11] := COLOR_GREEN_METRO
   aObj2But[4,12] := { || MyButtonRun4(), TblFocus()  } 
   aObj2But[4,13] := '    : 1  2'   // 
   aObj2But[4,16] := .T.  //  BOLD                  
   aObj2But[4,17] := .T.   // F-   (INVISIBLE)                 
   // ----------------------
   aObj2But[5, 1] := "oBut_Exit"              
   aObj2But[5, 7] := "iExit48x1"              
   aObj2But[5, 8] := "iExit48x2"              
   aObj2But[5,11] := COLOR_RED_METRO
   aObj2But[5,12] := { || SetProperty(cForm, "oBut_Exit", "Enabled", .F.) ,;
                          DoMethod( cForm, "Release" ) } 
   aObj2But[5,16] := .T.  //  BOLD                  

   // -----------     -----------
   //      
   FOR nI := 1 TO LEN(aObj2But)
       METRO3BUTTON(aObj2But[nI], NIL, cFont, aF2Color, , , )
   NEXT

   ///////////////////////////   ////////////////////////////////////
   aObj3But := {}
   IF M->nPubLang == 1
      aCapt := { ""  , "", "", "", ""  }
   ELSE
      aCapt := { ""  , "Copy"      , "Copy"      , "Cancel", ""  }
   ENDIF
   //   |  1   |  2 |   3    |  4   |  5   |   6    |  7  |  8   |   9  |  10   | 11 |    12                 | 13|14 | 15| 16| 17
   FOR nI := 1 TO LEN(aCapt)
      AADD( aObj3But, {"oBut_?",nRow,aCol[nI],nWButt,nHButt,aCapt[nI],"4x1","4x2",nFSize,aFColor, {} ,{|| ThisWindow.Release },'',.F.,.F.,.F.,.F. } )
   NEXT
   // ----------------------
   aObj3But[1, 1] := "oBut_Not2x1"              
   aObj3But[1,11] := COLOR_DARK_BLUE
   aObj3But[1,12] := { || MsgDebug( this.name ), TblFocus() }
   aObj3But[1,17] := .T.   // F-   (INVISIBLE)                 
   // ----------------------
   aObj3But[2, 1] := "oBut_Copy1to2"              
   aObj3But[2, 7] := "iCopy12x48x1"              
   aObj3But[2, 8] := "iCopy12x48x2"              
   aObj3But[2,11] := COLOR_BRIGHT_GREEN
   aObj3But[2,12] := { || MyButtonCopyFile(12,aObj3But[2,13])  } 
   aObj3But[2,13] := '    1   2'   // 
   aObj3But[2,16] := .T.  //  BOLD                  
   aObj3But[2,17] := .T.   // F-   (INVISIBLE)                 
   // ----------------------
   aObj3But[3, 1] := "oBut_Copy2to1"              
   aObj3But[3, 7] := "iCopy21x48x1"              
   aObj3But[3, 8] := "iCopy21x48x2"              
   aObj3But[3,11] := COLOR_BRIGHT_GREEN
   aObj3But[3,12] := { || MyButtonCopyFile(21,aObj3But[3,13])  } 
   aObj3But[3,13] := '    2   1'   // 
   aObj3But[3,16] := .T.  //  BOLD                  
   aObj3But[3,17] := .T.   // F-   (INVISIBLE)                 
   // ----------------------
   aObj3But[4, 1] := "oBut_Cancel"              
   aObj3But[4, 7] := "iCancel48x1"              
   aObj3But[4, 8] := "iCancel48x2"              
   aObj3But[4,11] := COLOR_BRIGHT_RED
   aObj3But[4,12] := { || SetProperty(oBrw1:cParentWnd, oBrw1:cControlName, "Enabled", .F.),;
                          DbSetorder(0), DBCLEARINDEX() , oBrw1:Reset(), ;
                          oBrw1:lNoHScroll := .F., oBrw1:ResetVScroll(), oBrw1:Refresh(.T.), ;
                          SetProperty(oBrw1:cParentWnd, oBrw1:cControlName, "Enabled", .T.),; 
                          Foot5Size(5,oBrw1), Foot8Itog(8,oBrw1), ;
                          MyButt1Visible() , TblFocus()   } 
   //oBrw1:lNoHScroll  := .T.  //    
   // oBrw1:ResetVScroll()      //   
   //oBrw1:Reset()
   //oBrw1:Refresh(.T.) 

   aObj3But[4,16] := .T.  //  BOLD                  
   aObj3But[4,17] := .T.   // F-   (INVISIBLE)                 
   // ----------------------
   aObj3But[5, 1] := "oBut_Not4x1"              
   aObj3But[5,12] := { || MsgDebug( this.name, "Rezerv!" ), TblFocus()  } 
   aObj3But[5,17] := .T.   // F-   (INVISIBLE)                 

   // -----------     -----------
   //      
   FOR nI := 1 TO LEN(aObj3But)
       METRO3BUTTON(aObj3But[nI], NIL, cFont, aF2Color, , , )
   NEXT

ELSE

   // -    
   aButtShow := {}
   // -----------    -----------
   FOR nI := 1 TO LEN(aObj2But)
       cObject := aObj2But[nI,1]
       AADD( aButtShow, aObj2But[nI,17]  )  // /   
       SetProperty(ThisWindow.Name, cObject, "Visible", .F.) 
   NEXT
   // -----------    -----------
   FOR nI := 1 TO LEN(aObj2But)
       cObject := aObj2But[nI,1]
       SetProperty(ThisWindow.Name, cObject, "Row"  , nRow     ) 
       SetProperty(ThisWindow.Name, cObject, "Col"  , aCol[nI] ) 
       IF aButtShow[nI] # .T.  //     -  
          SetProperty(ThisWindow.Name, cObject, "Visible", .T.) 
       ENDIF
   NEXT
   // -----------      -----------
   FOR nI := 1 TO LEN(aObj3But)
       cObject := aObj3But[nI,1]
       SetProperty(ThisWindow.Name, cObject, "Row"  , nRow     ) 
       SetProperty(ThisWindow.Name, cObject, "Col"  , aCol[nI] ) 
   NEXT

ENDIF // !lHideShow   

RETURN NIL

////////////////////////////////////////////////////////////////////////
FUNCTION MyTitleSHLang()
  LOCAL cText := MyTitleSHeader()

  oBrw1:aSuperHead[1,3] := cText  //  

  TblFocus()

Return Nil

////////////////////////////////////////////////////////////////////////
FUNCTION MyTitleSHeader()
    LOCAL cStr, cPath1, cPath2, cPathPrj

    //    HbpMerge.cnfg
    MyConfigLoad(@cPath1,@cPath2,@cPathPrj)

    IF M->nPubLang == 1
       cStr := SPACE(20)+"     :" + CRLF
       cStr += "  1 - " + cPath1 + CRLF
       cStr += "  2 - " + cPath2 + CRLF
       cStr += "   - " + cPathPrj
    ELSE
       cStr := SPACE(20)+"Folder comparison and the project for comparison:" + CRLF
       cStr += " Folder 1 - " + cPath1 + CRLF
       cStr += " Folder 2 - " + cPath2 + CRLF
       cStr += " Project  - " + cPathPrj
    ENDIF

Return cStr
////////////////////////////////////////////////////////////////////////
FUNCTION FunSHeader()
  LOCAL cText

  MyEditSuperHeader() 

  cText := MyTitleSHeader()

  oBrw1:aSuperHead[1,3] := cText  //  

  TblFocus()

Return Nil

//////////////////////////////////////////////////////////////////////
STATIC FUNCTION RunFile(nVal)
    LOCAL cFile

    IF nVal == 1
      cFile := ALLTRIM( (oBrw1:cAlias)->PATH1 ) + ALLTRIM( (oBrw1:cAlias)->FILE1 )
    ELSE
      cFile := ALLTRIM( (oBrw1:cAlias)->PATH2 ) + ALLTRIM( (oBrw1:cAlias)->FILE2 )
    ENDIF

    IF LEN(cFile) > 0
      // Using ShellExecute for opening Explorer with selected File
      ShellExecute( , 'open', cFile, , "" , 1 )
    ENDIF

Return cFile

//////////////////////////////////////////////////////////////////////
STATIC FUNCTION RunCompare()
   LOCAL cMsg, aDim[2], cRun, cPath1, cPath2

   IF M->nPubLang == 1
      aDim[1] := "    !;;" 
      aDim[2] := "    !;;"  
   ELSE
      aDim[1] := "There is such a program !;;"
      aDim[2] := "The program is in the process of development !;;"
   ENDIF

    cRun := UPPER( ALLTRIM( (oBrw1:cAlias)->RUNFUNC ) )
    IF cRun == "WINMERGE"
       cPath1 := ALLTRIM( (oBrw1:cAlias)->PATH1 ) + ALLTRIM( (oBrw1:cAlias)->FILE1 )
       cPath2 := ALLTRIM( (oBrw1:cAlias)->PATH2 ) + ALLTRIM( (oBrw1:cAlias)->FILE2 )
       IF LEN(cPath1) == 0 .AND. LEN(cPath2) == 0 
          //  
       ELSE
          RunWinMerge()
       ENDIF
    ELSEIF cRun == "DBFMERGE"
       cMsg := aDim[1]
       cMsg += aDim[2]
       cMsg := AtRepl( ";", cMsg, CRLF )
       MsgStop( cMsg )
    ENDIF

Return NIL
