/*
 * MINIGUI - Harbour Win32 GUI library 
 *
 * Team library offline http://clipper.borda.ru/ 
*/

#include "minigui.ch"

*----------------------------------- 
Function SwitchToWin( cForm ) 
*----------------------------------- 
  
    If _IsWindowDefined( cForm ) 
       If IsIconic( GetFormHandle(cForm) ) 
          _Restore( GetFormHandle(cForm) ) 
       Else 
          DoMethod( cForm, "SetFocus" ) 
       EndIf 
    EndIf 
  
Return Nil

////////////////////////////////////////////////////////////////////
Function ShowYX()
LOCAL cWin, cText, x, y, aColor := {0,0,0}

   cWin := _HMG_ThisFormName
   x := _HMG_MouseCol
   y := _HMG_MouseRow
   cText := "y: "+STR(y,4)+" x: "+STR(x,4)
   SETPROPERTY(cWin, "Title", cText)

Return Nil

////////////////////////////////////////////////////////////////////
Function CopyClipboardSet()
LOCAL hdc, x, y, aColor := {0,0,0}, cText

   x := _HMG_MouseCol
   y := _HMG_MouseRow

   cText := STR(y,4)+","+STR(x,4)
   System.Clipboard := cText
   MsgInfo("Data is placed in the clipboard !" + CRLF + CRLF + cText, "Mouse(y,x) + Clipboard")

Return Nil

////////////////////////////////////////////////////////////////////
//   
FUNCTION MyRGB(aDim)
   RETURN RGB(aDim[1],aDim[2],aDim[3])

//////////////////////////////////////////////////////////////////////////////////////
//     
FUNCTION RedrawAll()
Local aCtrls := _GetArrayOfAllControlsForForm ( _HMG_ThisFormName )
Local nI, CtrlName

FOR nI := 1 TO LEN(aCtrls)
    CtrlName := aCTrls[nI]
    IF AT("DUMMYMENUNAME", UPPER(CtrlName) ) > 0
       // , ..   -
    ELSE
       SetProperty( _HMG_ThisFormName, CtrlName, "Visible" , .F. )
       SetProperty( _HMG_ThisFormName, CtrlName, "Visible" , .T. )
    ENDIF
NEXT

Return NIL

/*************** MiniGUI\SAMPLES\BASIC\Form_Controls **************************/
Function _GetArrayOfAllControlsForForm ( cFormName )
/******************************************************************************/
Local nFormHandle , i , nControlCount , aRetVal := {} , x

nFormHandle := GetFormHandle ( cFormName )
nControlCount := Len ( _HMG_aControlHandles )
For i := 1 To nControlCount
   If _HMG_aControlParentHandles[i] == nFormHandle
      If ValType( _HMG_aControlHandles[i] ) == 'N'
         IF ! Empty( _HMG_aControlNames[i] )
            If Ascan( aRetVal, _HMG_aControlNames[i] ) == 0
               Aadd( aRetVal, _HMG_aControlNames[i] )
            EndIf
         ENDIF
      ElseIf ValType( _HMG_aControlHandles [i] ) == 'A'
         For x := 1 To Len ( _HMG_aControlHandles[i] )
            IF !Empty( _HMG_aControlNames[i] )
               If Ascan( aRetVal, _HMG_aControlNames[i] ) == 0
                  Aadd( aRetVal, _HMG_aControlNames [i] )
               EndIf
            ENDIF
         Next x
      EndIf
   EndIf
Next i
Return Asort( aRetVal )

///////////////////////////////////////////////////////////////////////////////////
//cMsg := "----> Output Protocol. Called from: " + ProcName( 1 ) + "(" + hb_ntos( ProcLine( 1 ) ) + ") --> " + ProcFile( 1 ) + CRLF + CRLF
//      STRFILE(cMsg,cFileLog,.F.)  //   
//      MsgFile(cFileLog,"nI=",nI,cAddress,ValType(cAddress),xFlat,ValType(xFlat) ) // 
*-----------------------------------------------------------------------------*
FUNCTION MsgFile( ... )
*-----------------------------------------------------------------------------*
   LOCAL i, cMsg:="", nCnt := PCount()

   //cMsg := "Called from: " + ProcName( 1 ) + "(" + hb_ntos( ProcLine( 1 ) ) + ") --> " + ProcFile( 1 ) + CRLF + CRLF

   FOR i = 2 TO nCnt
      cMsg += hb_ValToExp( PValue( i ) ) + iif( i < nCnt, ", ", "" )
   NEXT
   cMsg := ATREPL( "\r", cMsg, ""   )
   cMsg := ATREPL( "\n", cMsg, CRLF )
   STRFILE(cMsg + CRLF, PValue( 1 ), .T.)
   //MsgInfo( cMsg, "DEBUG INFO" )
RETURN NIL

/////////////////////////////////////////////////////////////////
FUNCTION _uVal2Txt( xVal )
LOCAL cTx, cTp:= ValType( xVal )

 IF     cTp=='C' ; cTx := AllTrim(xVal) ; RETURN iif(Empty(cTx), "'"+"'", cTx)
 ELSEIF cTp=='N' ; RETURN LTrim(Str(xVal)) 
 ELSEIF cTp=='L' ; RETURN iif(xVal, ".T.", ".F.")
 ELSEIF cTp=='D' ; cTx := DToS( xVal ) ;  RETURN Right(cTx,2)+'.'+subs(cTx,5,2)+'.'+Left(cTx,4)
 ELSEIF cTp=='A' ; RETURN "ARRAY["  + hb_NToS( Len(xVal) ) + "]" 
 ELSEIF cTp=='B' ; RETURN "'" + "B" + "'"
 ELSEIF cTp=='U' ; RETURN 'NIL'
 ENDIF   

RETURN "'" + cTp + "'"

///////////////////////////////////////////////////////////////////////////
FUNCTION MsgLog( )
LOCAL i, aParams, nParams
LOCAL hFile, cFile:="_MsgLog.txt"

 aParams  := hb_aParams()
 nParams  := PCount()

 IF nParams < 1 ; RETURN NIL
 ENDIF

 hFile := iif( File(cFile), FOpen(cFile,2) , FCreate(cFile) )

 FSeek( hFile, 0, 2)

 FOR i := 1 TO nParams
     FWrite(hFile, _uVal2Txt( aParams[i] ) + Chr(9) )
 NEXT

 FWrite(hFile, Chr(13)+Chr(10), 2 )

 FClose( hFile )

RETURN NIL

//////////////////////////////////////////////////////////////////////
Function METRO3BUTTON(  aDim , cForm, cFont, aFontColorInvert, lTextLeft, lTextVertical, lHide)
LOCAL cObject := aDim[1], nRow := aDim[2], nCol := aDim[3]
LOCAL nWidth  := aDim[4], nHeight := aDim[5], cCaption := AtRepl( ";", aDim[6], CRLF ) 
LOCAL cResIco := aDim[7], cResIco2 := aDim[8]
LOCAL nFontSize := aDim[9], aFontColor := aDim[10], aBACKCOLOR := aDim[11]
LOCAL bAction := aDim[12], cTooltip := aDim[13], lFontBold := .T.

DEFAULT lTextLeft := .F., lTextVertical := .T., lHide := .F.
DEFAULT cForm := _HMG_ThisFormName, cFont := 'Tahona', aFontColorInvert := BLACK

IF LEN(aDim) >= 14
   lTextLeft := aDim[14]
ENDIF
IF LEN(aDim) >= 15
   lTextVertical := aDim[15]
ENDIF
IF LEN(aDim) >= 16
   lFontBold := aDim[16]
ENDIF
IF LEN(aDim) >= 17
   lHide := aDim[17]
ENDIF

    DEFINE BUTTONEX &cObject
            PARENT &cForm 
      	    ROW  nRow
            COL  nCol
            WIDTH  nWidth
            HEIGHT nHeight
            ICON cResIco 
            CAPTION cCaption
            ACTION  Eval( bAction )
            TOOLTIP cTooltip
            VERTICAL lTextVertical
            LEFTTEXT lTextLeft 
            FLAT .F.
            FONTNAME cFont
            FONTSIZE nFontSize
            FONTBOLD lFontBold
            FONTCOLOR aFontColor
            BACKCOLOR aBACKCOLOR
            UPPERTEXT .F.
            NOHOTLIGHT .F.
            NOXPSTYLE .T.
            HANDCURSOR .T.
            ONMOUSEHOVER ( SetProperty(ThisWindow.Name, this.name, "ICON", cResIco2), SetProperty(ThisWindow.Name, cObject, "fontcolor", aFontColorInvert ) )
            ONMOUSELEAVE ( SetProperty(ThisWindow.Name, this.name, "ICON", cResIco) , SetProperty(ThisWindow.Name, cObject, "fontcolor", aFontColor) )
            NOTABSTOP .F. 
            INVISIBLE lHide 
    END BUTTONEX
    _SetGetUserData (cObject, cForm, cObject)  // Cargo

/*  			ONMOUSEHOVER ( SetProperty( cWin, this.name, "BackColor", aButtColorDuro ), ;
  				SetProperty( cWin, this.name, "FontColor", aButtColorMarker ), ChangeIcon( cWin, this.name, aIcons ) )
  			ONMOUSELEAVE ( SetProperty( cWin, this.name, "BackColor", aButtBackColor ), ;
  				SetProperty( cWin, this.name, "FontColor", aButtFontColor ), RestoreIcon(cWin) )
*/


//MsgDebug(cObject,GetProperty(cForm, cObject, "Fontname"),;
//                  GetProperty(cForm, cObject, "Fontsize"))

//   Eval( bAction ) :
// _HMG_aControlProcedures [ GetControlIndex(cObject, cForm) ] := bAction
// SetProperty(cForm, cObject, bAction) 
// Form_1.Button_1.Action := bAction

//MsgLog(cObject, cFont, nFontSize)
Return NIL

//////////////////////////////////////////////////////////////////////////
#pragma BEGINDUMP

#define HB_OS_WIN_32_USED
#define _WIN32_WINNT 0x0400
#include <windows.h>
#include "hbapi.h"

HB_FUNC (GETDESKTOPREALTOP)
{
RECT rect;
SystemParametersInfo( SPI_GETWORKAREA, 1, &rect, 0 );

hb_retni(rect.top);

}
HB_FUNC (GETDESKTOPREALLEFT)
{
RECT rect;
SystemParametersInfo( SPI_GETWORKAREA, 1, &rect, 0 );

hb_retni(rect.left);

}

HB_FUNC (GETDESKTOPREALWIDTH)
{
RECT rect;
SystemParametersInfo( SPI_GETWORKAREA, 1, &rect, 0 );

hb_retni(rect.right - rect.left);

}

HB_FUNC (GETDESKTOPREALHEIGHT)
{
RECT rect;
SystemParametersInfo( SPI_GETWORKAREA, 1, &rect, 0 );

hb_retni(rect.bottom - rect.top);
}

#pragma ENDDUMP

///////////////////////////////////////////////////////////////////////////////////////////
// SergKis  http://clipper.borda.ru/?1-1-0-00000389-000-0-1-1408089634
// 
// GETCLIENTHEIGHT(0) -   ()  Desktop     Start
// GETCLIENTWIDTH(0) -   ()  Desktop
// GETCLIENTHEIGHT(hWnd) -   ()   ( )
// GETCLIENTWIDTH(hWnd) -   ()   ( )
// ..:
// hWnd := GetFormHandle('Form_0')
// CreateBrowse( "oBrw_1", 'Form_0', 32, 2, GetClientWidth(hWnd), GetClientHeight(hWnd), 'LOG_DBF' )

#pragma BEGINDUMP

#include <windows.h>
#include "hbapi.h"

HB_FUNC( GETCLIENTWIDTH )
{
RECT rect;

GetClientRect( ( HWND ) hb_parnl(1), &rect );
hb_retni( ( INT ) rect.right - rect.left );
}

HB_FUNC( GETCLIENTHEIGHT )
{
RECT rect;

GetClientRect( ( HWND ) hb_parnl(1), &rect );
hb_retni( ( INT ) rect.bottom - rect.top );
}

HB_FUNC( GETCLIENTTOP )
{
   HWND hWnd = ( HWND ) hb_parni( 1 );
   int nRow = hb_parni( 2 );
   int nHeightCell = hb_parni( 3 );
   int nHeightFoot = hb_parni( 4 );
   int nHeightHead = hb_parni( 5 );
   int nHeightSuper = hb_parni( 6 );
   int nHeightSpec = hb_parni( 7 );
   int nHeadFoot = hb_parni( 8 );
   BOOL bFooter = ( nHeadFoot == 2 ? TRUE : FALSE );
   RECT rect;

GetClientRect( ( HWND ) hb_parnl(1), &rect );

rect.top = ( bFooter ? rect.bottom - nHeightFoot + 1 : nHeightHead + nHeightSuper - ( nHeightSuper ? 1 : 0 ) + nHeightSpec + ( nHeightCell * ( nRow - 1 ) ) );
hb_retni( ( INT ) rect.top );
}
HB_FUNC( GETCLIENBOTTOM )
{
RECT rect;

GetClientRect( ( HWND ) hb_parnl(1), &rect );
hb_retni( ( INT ) rect.bottom );
}

#pragma ENDDUMP

//------------------------------------------------------------------------------
Function KeyToChar( nVirtKey )
//------------------------------------------------------------------------------
   LOCAL i, cRetChar := ""
   LOCAL nKeyboardMode := GetKeyboardMode()
   LOCAL lShift := CheckBit( GetKeyState( 16 ), 32768 )
   LOCAL aKeysNumPad := { 96,97,98,99,100,101,102,103,104,105,106,107,109,110,111 }
   LOCAL cKeysNumPad := "0123456789*+-./"
   LOCAL aKeys1 := { 192,189,187,219,221,220,186,222,188,190,191 }
   LOCAL cKeys1US := "`-=[]\;',./"
   LOCAL cKeys1ShiftUS := '~_+{}|:"<>?'
   LOCAL cKeys1RU := "-=\."
   LOCAL cKeys1ShiftRU := "_+/,"
   LOCAL cKeys2US := "1234567890QWERTYUIOPASDFGHJKLZXCVBNM "
   LOCAL cKeys2ShiftUS := "!@#$%^&*()QWERTYUIOPASDFGHJKLZXCVBNM "
   LOCAL cKeys2RU := "1234567890 "
   LOCAL cKeys2ShiftRU := '!";%:?*() '

   i := ascan( aKeysNumPad, nVirtKey )
   if i > 0
      RETURN substr( cKeysNumPad, i, 1 )
   endif

   i := ascan( aKeys1, nVirtKey )
   if i > 0
      if nKeyboardMode == 1033 // US
         if lShift
            cRetChar := substr( cKeys1ShiftUS, i, 1 )
         else
            cRetChar := substr( cKeys1US, i, 1 )
         endif
      elseif nKeyboardMode == 1049 // RU
         if lShift
            cRetChar := substr( cKeys1ShiftRU, i, 1 )
         else
            cRetChar := substr( cKeys1RU, i, 1 )
         endif
      endif
      RETURN cRetChar
   endif

   i := at( chr( nVirtKey ), cKeys2US )
   if i > 0
      if nKeyboardMode == 1033 // US
         if lShift
            cRetChar := substr( cKeys2ShiftUS, i, 1 )
         else
            cRetChar := substr( cKeys2US, i, 1 )
         endif
      elseif nKeyboardMode == 1049 // RU
         if lShift
            cRetChar := substr( cKeys2ShiftRU, i, 1 )
         else
            cRetChar := substr( cKeys2RU, i, 1 )
         endif
      endif
   endif

   RETURN cRetChar

//------------------------------------------------------------------------------
#pragma BEGINDUMP

#include <windows.h>
#include "hbapi.h"
#include "hbapiitm.h"

HB_FUNC( GETKEYBOARDMODE )
{
   HKL kbl;
   HWND CurApp;
   DWORD idthd;
   int newmode;

   CurApp=GetForegroundWindow();
   idthd=GetWindowThreadProcessId(CurApp,NULL);

   kbl=GetKeyboardLayout(idthd);
   newmode=(int)LOWORD(kbl);

   hb_retnl(newmode);
}
#pragma ENDDUMP

/*------------------------------------------------------------------------------	
*      http://clipper.borda.ru/?1-4-0-00000995-000-0-0-1408978369
*
lis_eng := lis_eng_kbd(@rsl)
...
KB_ENG()
...

KB_RUS()
...
*/

Function lis_eng_kbd(rsl)
rsl:=RASKLADKA()
return (rsl== "00000409") //eng

Function lis_rus_kbd(rsl)
rsl:=RASKLADKA()
return (rsl== "00000419") //rus

Function KB_LANG()
Local rsl, cRet := "???"

rsl:=RASKLADKA()
IF rsl == "00000409"
   cRet := "ENG"
ELSEIF rsl == "00000419"
   cRet := "RUS"
ENDIF

return cRet


#pragma BEGINDUMP

#include "Windows.h"
#include "hbapi.h"

HB_FUNC(KB_RUS) { LoadKeyboardLayout("00000419", KLF_ACTIVATE) ; }
HB_FUNC(KB_ENG) { LoadKeyboardLayout("00000409", KLF_ACTIVATE) ; }

HB_FUNC(RASKLADKA)
{
TCHAR m_PreviousLayout[KL_NAMELENGTH] ;
GetKeyboardLayoutName(m_PreviousLayout);
hb_retc(m_PreviousLayout);
}

#pragma ENDDUMP 


////////////////////////////////////////////////////////////////////////////////

#pragma BEGINDUMP

#include <windows.h>
#include "hbapi.h"
#include "hbapiitm.h"

HB_FUNC ( SHOWFILEPROPERTIES )
{
	SHELLEXECUTEINFO ShExecInfo;

	ShExecInfo.cbSize       = sizeof(SHELLEXECUTEINFO);
	ShExecInfo.fMask        = SEE_MASK_INVOKEIDLIST;
	ShExecInfo.hwnd         = GetActiveWindow();
	ShExecInfo.lpVerb       = "properties";
	ShExecInfo.lpFile       = hb_parc(1);
	ShExecInfo.lpParameters = ""; 
	ShExecInfo.lpDirectory  = NULL;
	ShExecInfo.nShow        = SW_SHOW;
	ShExecInfo.hInstApp     = NULL; 

	ShellExecuteEx(&ShExecInfo);
}


#pragma ENDDUMP


*-----------------------------------------------------------------------------*
//     / Icon associated with the file type

#pragma BEGINDUMP

#include "hbapi.h"
#include "windows.h"
#include <shellapi.h>

extern HBITMAP Icon2Bmp( HICON hIcon );

HB_FUNC( EXTRACTASSICON )
{
HICON hIcon;
LONG hInstance = hb_parnl( 1 );
char * lpIconPath = ( char * ) hb_parc( 2 );
WORD lpiIcon = hb_parnl( 3 );

hIcon = ExtractAssociatedIcon(
( HINSTANCE ) hInstance,
lpIconPath,
&lpiIcon );

hb_stornl( lpiIcon, 3 );
hb_retnl( ( LONG ) hIcon );

}

HB_FUNC( NEXTRACTASSICON )
{
HICON hIcon;
LONG hInstance = hb_parnl( 1 );
char * lpIconPath = ( char * ) hb_parc( 2 );
WORD lpiIcon = hb_parnl( 3 );

hIcon = ExtractAssociatedIcon(
( HINSTANCE ) hInstance,
lpIconPath,
&lpiIcon );

hb_retnl( ( LONG ) Icon2Bmp( hIcon ) );
DestroyIcon(hIcon);
}

HB_FUNC( DESTROYICON)
{HICON hIcon = (HICON) hb_parnl( 1 );
DestroyIcon(hIcon);
}
HB_FUNC( ICON_EXEREAD )
{
SHFILEINFO sfi;

ZeroMemory(&sfi, sizeof(SHFILEINFO));

/*SHGetFileInfo(hb_parc(1), 0, &sfi, sizeof(SHFILEINFO), SHGFI_ICON | SHGFI_SHELLICONSIZE | SHGFI_USEFILEATTRIBUTES ); */
SHGetFileInfo(hb_parc(1), 0, &sfi, sizeof(SHFILEINFO), SHGFI_ICON | SHGFI_USEFILEATTRIBUTES );

hb_retnl( ( LONG ) sfi.hIcon );

}

HB_FUNC( BMPFROMICON )
{
HICON hIcon = ( HICON ) hb_parnl( 1 );

hb_retnl( ( LONG ) Icon2Bmp( hIcon ) );
}

#pragma ENDDUMP

